﻿Imports System.Xml
Imports System.IO

Module Armory
    Public Sub doArmoryImport(ByVal charac, ByVal realm, ByVal zone)
        Variables.LoadDisable = True
        Variables.rawGear.Clear()
        Variables.rawTalents = ""
        Variables.rawGlyphs = ""
        If zone = "" Then zone = "us"
        realm = Replace(realm, " ", "+")
        Dim character As String = "http://" & zone & ".wowarmory.com/character-sheet.xml?r=" & realm & "&n=" & charac
        Dim chartalent As String = "http://" & zone & ".wowarmory.com/character-talents.xml?r=" & realm & "&n=" & charac
        ' ITEMS
        Dim wc As New Net.WebClient
        wc.Headers.Add("user-agent", "MSIE 7.0")
        Dim XmlR As XmlReader
        XmlR = New Xml.XmlTextReader(wc.OpenRead(character))
        Do While XmlR.Read
            If XmlR.LocalName = "items" Then
                Using items As XmlReader = XmlR.ReadSubtree
                    While items.Read
                        If items.LocalName = "item" Then
                            Dim itemID As Integer = 0
                            Dim slot As Integer = 0
                            Dim gem0 As Integer = 0
                            Dim gem1 As Integer = 0
                            Dim gem2 As Integer = 0
                            Dim enchant As Integer = 0
                            Dim randomProp As Integer = 0

                            If items.MoveToAttribute("id") Then itemID = items.ReadContentAsInt
                            If items.MoveToAttribute("slot") Then slot = items.ReadContentAsInt
                            If items.MoveToAttribute("gem0Id") Then gem0 = items.ReadContentAsInt
                            If items.MoveToAttribute("gem1Id") Then gem1 = items.ReadContentAsInt
                            If items.MoveToAttribute("gem2Id") Then gem2 = items.ReadContentAsInt
                            If items.MoveToAttribute("permanentenchant") Then enchant = items.ReadContentAsInt
                            If items.MoveToAttribute("randomPropertiesId") Then randomProp = items.ReadContentAsInt

                            ' Add the gear to the array.
                            rawGear.Add(slot & "," & itemID & "," & gem0 & "," & gem1 & "," & gem2 & "," & enchant & "," & randomProp)

                            ' Assign item to item slot in UI through ProgressChanged event.
                            Form1.ArmoryWorker.ReportProgress(5, "0," & slot & "," & itemID)
                        End If
                    End While
                    items.Close()
                End Using
            ElseIf XmlR.LocalName = "character" Then
                ' Hack to avoid importing character data for player's arena partners.
                ' The character we want always has an empty battleGroup (For now!)
                Dim bg As String = ""
                If XmlR.MoveToAttribute("battleGroup") Then bg = XmlR.ReadContentAsString
                If bg <> "" Then
                    If XmlR.MoveToAttribute("race") Then Variables.StoredRace = XmlR.ReadContentAsString
                    If XmlR.MoveToAttribute("level") Then Variables.StoredShamanLevel = XmlR.ReadContentAsInt
                End If
            End If
        Loop
        XmlR.Close()
        XmlR = Nothing
        wc.Dispose()
        wc = Nothing

        ' TALENTS
        Dim wc0 As New Net.WebClient
        wc0.Headers.Add("user-agent", "MSIE 7.0")
        Dim XmlT As XmlReader = New XmlTextReader(wc0.OpenRead(chartalent))
        Do While XmlT.Read
            If XmlT.LocalName = "talentGroup" Then
                Using Talents As XmlReader = XmlT.ReadSubtree
                    While Talents.Read
                        ' Talents
                        If Talents.MoveToAttribute("value") Then
                            Dim tmpTalents As String = Talents.ReadContentAsString
                            Dim cheapHack As Integer = CInt(tmpTalents.Substring(20, 4))
                            If cheapHack > 0 Then rawTalents = tmpTalents
                        End If
                        ' Glyphs
                        If Talents.MoveToAttribute("name") Then
                            rawGlyphs &= Talents.ReadContentAsString & vbCrLf
                        End If
                    End While
                End Using
            End If
        Loop
        XmlT.Close()
        XmlT = Nothing
        wc0.Dispose()
        wc0 = Nothing
        Variables.LoadDisable = False
    End Sub

    Public Sub parseTalents()
        If rawTalents.Length > 0 Then
            Form1.Concussion.Text = rawTalents.Substring(1, 1)
            Form1.CallofFlame.Text = rawTalents.Substring(2, 1)
            Form1.ElementalFury.Text = rawTalents.Substring(7, 1)
            If rawTalents.Substring(11, 1) = "1" Then Form1.CallofThunder.Checked = True Else Form1.CallofThunder.Checked = False
            Form1.ElementalPrecision.Text = rawTalents.Substring(13, 1)
            Form1.StormEarthFire.Text = rawTalents.Substring(16, 1)
            Form1.BoomingEchoes.Text = rawTalents.Substring(17, 1)
            Form1.ElementalOath.Text = rawTalents.Substring(18, 1)
            Form1.LightningOverload.Text = rawTalents.Substring(19, 1)
            Form1.LavaFlows.Text = rawTalents.Substring(22, 1)
            Form1.Shamanism.Text = rawTalents.Substring(23, 1)
            Form1.AncestralKnowledge.Text = rawTalents.Substring(27, 1)
            Form1.ThunderingStrikes.Text = rawTalents.Substring(29, 1)
            Form1.ElementalWeapons.Text = rawTalents.Substring(32, 1)
        End If

        If rawGlyphs.Length > 0 Then
            Form1.GoFTWCheckBox.Checked = False
            Form1.GoLCheckBox.Checked = False
            Form1.GoLBCheckBox.Checked = False
            Form1.GoToWCheckBox.Checked = False

            Dim sGlyphs() As String = Split(Variables.rawGlyphs, vbCrLf)
            Dim sinGlyph As String = ""
            For Each sinGlyph In sGlyphs
                If sinGlyph = "Glyph of Flametongue Weapon" Then Form1.GoFTWCheckBox.Checked = True
                If sinGlyph = "Glyph of Lava" Then Form1.GoLCheckBox.Checked = True
                If sinGlyph = "Glyph of Lightning Bolt" Then Form1.GoLBCheckBox.Checked = True
                If sinGlyph = "Glyph of Totem of Wrath" Then Form1.GoToWCheckBox.Checked = True
            Next
        End If
    End Sub

    Public Sub parseGear()
        Variables.LoadDisable = True
        Variables.CurrentGear.Clear()
        Variables.CurrentGems.Clear()
        Variables.CurrentEnchants.Clear()
        Dim i As Integer = 0
        For i = 0 To Variables.rawGear.Count - 1
            'slot, itemID, gem0, gem1, gem2, enchant, randomProp - SLOT IS CHARSHEET SLOT, NOT ITEM (Wowhead) SLOT
            Dim rawLine() As String = Split(Variables.rawGear(i), ",")
            Dim slot As String = rawLine(0)
            Dim itemID As String = rawLine(1)
            Dim gem0 As String = rawLine(2)
            Dim gem1 As String = rawLine(3)
            Dim gem2 As String = rawLine(4)
            Dim enchant As String = rawLine(5)
            Dim randomProp As String = rawLine(6)

            Dim itemmatch As String = CheckItemDB(itemID.ToString, slot)
            Dim piece() As String = Split(itemmatch, ";")
            If gem0 <> "0" Or gem1 <> "0" Or gem2 <> "0" Then CheckGemDB(gem0, gem1, gem2)
            Dim enchantmatch As String = CheckEnchantDB(slot, enchant)

            If slot = "0" Then
                Form1.HeadCombo.Text = piece(2)
                Variables.CurrentGear.Add("Head", itemmatch)
                Variables.CurrentGems.Add("Head", gem0 & ";" & gem1 & ";" & gem2)
                Variables.CurrentEnchants.Add("Head", enchantmatch)
            ElseIf slot = "1" Then
                Form1.NeckCombo.Text = piece(2)
                Variables.CurrentGear.Add("Neck", itemmatch)
                Variables.CurrentGems.Add("Neck", gem0 & ";" & gem1 & ";" & gem2)
                Variables.CurrentEnchants.Add("Neck", enchantmatch)
            ElseIf slot = "2" Then
                Form1.ShouldersCombo.Text = piece(2)
                Variables.CurrentGear.Add("Shoulder", itemmatch)
                Variables.CurrentGems.Add("Shoulder", gem0 & ";" & gem1 & ";" & gem2)
                Variables.CurrentEnchants.Add("Shoulder", enchantmatch)
            ElseIf slot = "4" Then
                Form1.ChestCombo.Text = piece(2)
                Variables.CurrentGear.Add("Chest", itemmatch)
                Variables.CurrentGems.Add("Chest", gem0 & ";" & gem1 & ";" & gem2)
                Variables.CurrentEnchants.Add("Chest", enchantmatch)
            ElseIf slot = "5" Then
                Form1.WaistCombo.Text = piece(2)
                Variables.CurrentGear.Add("Waist", itemmatch)
                Variables.CurrentGems.Add("Waist", gem0 & ";" & gem1 & ";" & gem2)
                Variables.CurrentEnchants.Add("Waist", enchantmatch)
            ElseIf slot = "6" Then
                Form1.LegsCombo.Text = piece(2)
                Variables.CurrentGear.Add("Legs", itemmatch)
                Variables.CurrentGems.Add("Legs", gem0 & ";" & gem1 & ";" & gem2)
                Variables.CurrentEnchants.Add("Legs", enchantmatch)
            ElseIf slot = "7" Then
                Form1.FeetCombo.Text = piece(2)
                Variables.CurrentGear.Add("Feet", itemmatch)
                Variables.CurrentGems.Add("Feet", gem0 & ";" & gem1 & ";" & gem2)
                Variables.CurrentEnchants.Add("Feet", enchantmatch)
            ElseIf slot = "8" Then
                Form1.WristCombo.Text = piece(2)
                Variables.CurrentGear.Add("Wrist", itemmatch)
                Variables.CurrentGems.Add("Wrist", gem0 & ";" & gem1 & ";" & gem2)
                Variables.CurrentEnchants.Add("Wrist", enchantmatch)
            ElseIf slot = "9" Then
                Form1.HandsCombo.Text = piece(2)
                Variables.CurrentGear.Add("Hands", itemmatch)
                Variables.CurrentGems.Add("Hands", gem0 & ";" & gem1 & ";" & gem2)
                Variables.CurrentEnchants.Add("Hands", enchantmatch)
            ElseIf slot = "10" Then
                Form1.Finger1Combo.Text = piece(2)
                Variables.CurrentGear.Add("Finger1", itemmatch)
                Variables.CurrentGems.Add("Finger1", gem0 & ";" & gem1 & ";" & gem2)
                Variables.CurrentEnchants.Add("Finger1", enchantmatch)
            ElseIf slot = "11" Then
                Form1.Finger2Combo.Text = piece(2)
                Variables.CurrentGear.Add("Finger2", itemmatch)
                Variables.CurrentGems.Add("Finger2", gem0 & ";" & gem1 & ";" & gem2)
                Variables.CurrentEnchants.Add("Finger2", enchantmatch)
            ElseIf slot = "12" Then
                Form1.Trinket1Combo.Text = piece(2)
                Variables.CurrentGear.Add("Trinket1", itemmatch)
                Variables.CurrentGems.Add("Trinket1", gem0 & ";" & gem1 & ";" & gem2)
                Variables.CurrentEnchants.Add("Trinket1", enchantmatch)
            ElseIf slot = "13" Then
                Form1.Trinket2Combo.Text = piece(2)
                Variables.CurrentGear.Add("Trinket2", itemmatch)
                Variables.CurrentGems.Add("Trinket2", gem0 & ";" & gem1 & ";" & gem2)
                Variables.CurrentEnchants.Add("Trinket2", enchantmatch)
            ElseIf slot = "14" Then
                Form1.BackCombo.Text = piece(2)
                Variables.CurrentGear.Add("Back", itemmatch)
                Variables.CurrentGems.Add("Back", gem0 & ";" & gem1 & ";" & gem2)
                Variables.CurrentEnchants.Add("Back", enchantmatch)
            ElseIf slot = "15" Then
                Form1.MainHandCombo.Text = piece(2)
                Variables.CurrentGear.Add("MainHand", itemmatch)
                Variables.CurrentGems.Add("MainHand", gem0 & ";" & gem1 & ";" & gem2)
                Variables.CurrentEnchants.Add("MainHand", enchantmatch)
            ElseIf slot = "16" Then
                Form1.OffHandCombo.Text = piece(2)
                Variables.CurrentGear.Add("OffHand", itemmatch)
                Variables.CurrentGems.Add("OffHand", gem0 & ";" & gem1 & ";" & gem2)
                Variables.CurrentEnchants.Add("OffHand", enchantmatch)
            ElseIf slot = "17" Then
                Form1.RelicCombo.Text = piece(2)
                Variables.CurrentGear.Add("Relic", itemmatch)
                Variables.CurrentGems.Add("Relic", gem0 & ";" & gem1 & ";" & gem2)
                Variables.CurrentEnchants.Add("Relic", enchantmatch)
            End If
        Next
        Variables.LoadDisable = False
    End Sub

    Public Function CheckItemDB(ByVal itemID As String, ByVal slot As String)
        ' If the item is not in the item database, it should be added in.
        ' If it's added in, inform the parent to add it to the item Arrays.
        Dim itemMatch As String = ""
        If slot = "3" Or slot = "18" Then itemMatch = "Ignore"

        If itemMatch <> "Ignore" And Variables.AllItemsArray_Id.Contains(itemID) Then
            itemMatch = Variables.AllItemsArray_Id.Item(itemID)
        End If

        If itemMatch = "" Then
            itemMatch = parseGearFromWowhead(itemID)
            Dim s() As String = Split(itemMatch, ";")
            Variables.AllItemsArray_Id.Add(itemID, itemMatch)
            Variables.AllItemsArray_Name.Add(s(2), itemMatch)
            Form1.TextBox1.AppendText("Added new item to DB: " & s(2) & " (" & itemID & ") for slot: " & s(0) & vbCrLf)
        End If
        Return itemMatch
    End Function

    Public Sub CheckGemDB(ByVal gem0, ByVal gem1, ByVal gem2)
        Dim result As String = ""
        If gem0 <> "0" Then
            If Not Variables.GemHash_Id.Contains(gem0) Then
                result = parseGemFromWowhead(gem0)
                Dim s() As String = Split(result, ";")
                Variables.GemHash_Id.Add(gem0, result)
                Variables.GemHash_Name.Add(s(1), result)
                Form1.TextBox1.AppendText("Added new gem to DB: " & s(1) & " (" & gem0 & ")" & vbCrLf)
            End If
        End If
        If gem1 <> "0" Then
            If Not Variables.GemHash_Id.Contains(gem1) Then
                result = parseGemFromWowhead(gem1)
                Dim s() As String = Split(result, ";")
                Variables.GemHash_Id.Add(gem1, result)
                Variables.GemHash_Name.Add(s(1), result)
                Form1.TextBox1.AppendText("Added new gem to DB: " & s(1) & " (" & gem1 & ")" & vbCrLf)
            End If
        End If
        If gem2 <> "0" Then
            If Not Variables.GemHash_Id.Contains(gem2) Then
                result = parseGemFromWowhead(gem2)
                Dim s() As String = Split(result, ";")
                Variables.GemHash_Id.Add(gem2, result)
                Variables.GemHash_Name.Add(s(1), result)
                Form1.TextBox1.AppendText("Added new gem to DB: " & s(1) & " (" & gem2 & ")" & vbCrLf)
            End If
        End If
    End Sub

    Public Function CheckEnchantDB(ByVal slot, ByVal enchant)
        Dim result As String = ""
        If enchant <> "0" Then
            If Variables.EnchantHash_Id.Contains(enchant) Then
                result = Variables.EnchantHash_Id.Item(enchant)
            Else
                ' Convert the Charsheet slot # to the Wowhead slot #
                Dim newslot As String = Char2WowSlot(slot)
                ' ID;Name;Slot;SP;Crit;Hit;Haste;Int;Stam
                Dim values As String = enchant & ";" & enchant & ";" & newslot & ";0;0;0;0;0;0"
                addtoDataFile(values, "enchants")
                Form1.TextBox1.AppendText("Added new blank Enchant to DB.  ID/Name: " & enchant & vbCrLf)
                Variables.EnchantHash_Id.Add(enchant, values)
                Variables.EnchantHash_Name.Add(enchant, values)
                result = values
            End If
        End If
        Return result
    End Function

    Public Sub checkSocketBonusDB(ByVal bonus, ByVal itemId)
        If bonus <> "0" And bonus <> "" Then
            If Not Variables.SocketBonus_Id.Contains(bonus) Then
                Dim name As String = "No info for " & bonus
                Dim values As String = bonus & ";" & itemId & ";" & name & ";0;0;0;0;0;0;0"
                Form1.TextBox1.AppendText("Added new blank Socket Bonus to DB: ID/Name: " & bonus & ". First seen on itemID: " & itemId & vbCrLf)
                Variables.SocketBonus_Id.Add(bonus, values)
                Variables.SocketBonus_Name.Add(name, values)
                addtoDataFile(values, "socketbonus")
            End If
        End If
    End Sub

    Public Sub addtoDataFile(ByVal values, ByVal file)
        Dim a() As String = Split(values, ";")
        If a(0) <> "" Then
            Dim objWriter As New StreamWriter("Data\" & file & ".data", True)
            objWriter.WriteLine(values)
            objWriter.Close()
        End If
    End Sub

    Public Function parseGearFromWowhead(ByVal id As Integer)
        Try
            Dim name As String = ""
            Dim spldmg As String = ""
            Dim intel As String = ""
            Dim crit As String = ""
            Dim hit As String = ""
            Dim haste As String = ""
            Dim stam As String = ""
            Dim socket1 As String = ""
            Dim socket2 As String = ""
            Dim socket3 As String = ""
            Dim socketbonus As String = ""
            Dim armor As String = ""
            Dim itemset As String = ""
            Dim display As String = ""
            Dim unique As String = "0"
            Dim slot As String = ""

            Dim xmldoc As XmlDocument
            Dim xmlnlist0 As XmlNodeList
            Dim xmlnlist1 As XmlNodeList
            Dim xmln0 As XmlNode
            Dim xmln1 As XmlNode
            xmldoc = New XmlDocument
            xmldoc.Load("http://www.wowhead.com/?item=" & id & "&xml")
            xmlnlist0 = xmldoc.SelectNodes("/wowhead/item/name")
            For Each xmln0 In xmlnlist0
                name = Trim(xmln0.ChildNodes.Item(0).InnerText)
            Next
            xmlnlist1 = xmldoc.SelectNodes("/wowhead/item/jsonEquip")
            For Each xmln1 In xmlnlist1
                Dim rawdata() As String = Split(xmln1.ChildNodes.Item(0).InnerText, ",")
                Dim i As Integer = 0
                For i = 0 To UBound(rawdata)
                    Dim at() As String = Split(rawdata(i), ":")
                    at(0) = Replace(at(0), """", "")
                    If at(0) = "splpwr" Then
                        spldmg = Trim(at(1))
                    ElseIf at(0) = "int" Then
                        intel = Trim(at(1))
                    ElseIf at(0) = "hitrtng" Then
                        hit = Trim(at(1))
                    ElseIf at(0) = "critstrkrtng" Then
                        crit = Trim(at(1))
                    ElseIf at(0) = "hastertng" Then
                        haste = Trim(at(1))
                    ElseIf at(0) = "slotbak" Then
                        slot = Trim(at(1))
                    ElseIf at(0) = "sta" Then
                        stam = Trim(at(1))
                    ElseIf at(0) = "socket1" Then
                        socket1 = Trim(at(1))
                    ElseIf at(0) = "socket2" Then
                        socket2 = Trim(at(1))
                    ElseIf at(0) = "socket3" Then
                        socket3 = Trim(at(1))
                    ElseIf at(0) = "socketbonus" Then
                        socketbonus = Trim(at(1))
                    ElseIf at(0) = "armor" Then
                        armor = Trim(at(1))
                    ElseIf at(0) = "itemset" Then
                        itemset = Trim(at(1))
                    ElseIf at(0) = "displayid" Then
                        display = Trim(at(1))
                    ElseIf at(0) = "maxcount" Then
                        unique = Trim(at(1))
                    End If
                Next
            Next
            Dim passval As String = ""
            ' Wowhead sometimes uses Slot 20 for a Chest piece, along side Slot 5.
            If slot = "20" Then slot = "5"

            passval = slot & ";" & id & ";" & name & ";" & armor & ";" & itemset & ";" & socket1 & ";" & socket2 & ";" & socket3 & ";" & socketbonus & ";"
            passval &= intel & ";" & stam & ";" & spldmg & ";" & hit & ";" & crit & ";" & haste & ";" & display & ";" & unique
            checkSocketBonusDB(socketbonus, id)
            addtoDataFile(passval, "gear")
            xmldoc = Nothing
            Return passval
        Catch ex As Exception
            MessageBox.Show("Error importing: " & ex.Message)
            Return ""
        End Try
    End Function

    Public Function parseGemFromWowhead(ByVal id As Integer)
        Try
            ' ID;Name;Class;SP;Crit;Hit;Haste;Int;Stam;Hit Dmg;Crit Dmg - Class is which socket
            Dim name As String = ""
            Dim socket As String = ""
            Dim spldmg As String = ""
            Dim crit As String = ""
            Dim hit As String = ""
            Dim haste As String = ""
            Dim intel As String = ""
            Dim stam As String = ""
            Dim hitdmg As String = ""
            Dim critdmg As String = ""
            Dim unique As String = "0"

            Dim xmldoc As XmlDocument
            Dim xmlnlist1 As XmlNodeList
            Dim xmln1 As XmlNode
            xmldoc = New XmlDocument
            xmldoc.Load("http://www.wowhead.com/?item=" & id & "&xml")
            xmlnlist1 = xmldoc.SelectNodes("/wowhead/item/name")
            For Each xmln1 In xmlnlist1
                name = xmln1.ChildNodes.Item(0).InnerText
            Next
            xmln1 = Nothing

            xmlnlist1 = xmldoc.SelectNodes("/wowhead/item/subclass")
            For Each xmln1 In xmlnlist1
                socket = xmln1.Attributes.GetNamedItem("id").Value.ToString
            Next
            xmln1 = Nothing

            xmlnlist1 = xmldoc.SelectNodes("/wowhead/item/jsonEquip")
            For Each xmln1 In xmlnlist1
                Dim rawdata() As String = Split(xmln1.ChildNodes.Item(0).InnerText, ",")
                Dim i As Integer = 0
                For i = 0 To UBound(rawdata)
                    Dim at() As String = Split(rawdata(i), ":")
                    If at(0) = "splpwr" Then
                        spldmg = at(1)
                    ElseIf at(0) = "int" Then
                        intel = at(1)
                    ElseIf at(0) = "hitrtng" Then
                        hit = at(1)
                    ElseIf at(0) = "critstrkrtng" Then
                        crit = at(1)
                    ElseIf at(0) = "hastertng" Then
                        haste = at(1)
                    ElseIf at(0) = "sta" Then
                        stam = at(1)
                    ElseIf at(0) = "maxcount" Then
                        unique = at(1)
                    End If
                Next
            Next
            Dim passval As String = ""
            passval = id & ";" & name & ";" & socket & ";" & spldmg & ";" & crit & ";" & hit & ";" & haste & ";" & intel & ";"
            passval += stam & ";" & hitdmg & ";" & critdmg & ";" & unique
            addtoDataFile(passval, "gem")
            xmldoc = Nothing
            Return passval
        Catch ex As Exception
            MessageBox.Show("Error importing: " & ex.Message)
            Return ""
        End Try
    End Function

    Public Sub processGearInfo()
        ' Blank current values.
        Variables.IntFromGear = 0     ' 9
        Variables.SPFromGear = 0      ' 11
        Variables.HitFromGear = 0     ' 12
        Variables.CritFromGear = 0    ' 13
        Variables.HasteFromGear = 0   ' 14

        Dim item As DictionaryEntry
        For Each item In Variables.CurrentGear
            If item.Value <> "" And item.Value <> "0" Then
                Dim h() As String = Split(item.Value, ";")
                If h(9) <> "" Then Variables.IntFromGear += h(9)
                If h(11) <> "" Then Variables.SPFromGear += h(11)
                If h(12) <> "" Then Variables.HitFromGear += h(12)
                If h(13) <> "" Then Variables.CritFromGear += h(13)
                If h(14) <> "" Then Variables.HasteFromGear += h(14)
                If h(8) <> "" And h(8) <> "0" Then
                    ' Because we allow the user to not match sockets now, we need to confirm the slotted gems match the color to get the bonus.
                    ' What a pain in the ass.
                    Dim tainted As Integer = 0
                    ' Look up the currently selected gems in the gear.  item.key is the name of the slot
                    Dim gemIDs() As String = Split(Variables.CurrentGems.Item(item.Key), ";")
                    ' Determine if they match the slot colors.
                    If h(5) <> "" And h(5) <> "0" Then
                        ' If the gemID is 0, there is no gem in the slot.
                        If gemIDs(0) <> "0" Then
                            ' Get the color of the gem from it's ID, first socket
                            Dim gem0() As String = Split(Variables.GemHash_Id(gemIDs(0)), ";")
                            If h(5) = "2" And (gem0(2) <> "0" And gem0(2) <> "5" And gem0(2) <> "3") Then tainted = 1
                            If h(5) = "4" And (gem0(2) <> "2" And gem0(2) <> "5" And gem0(2) <> "4") Then tainted = 1
                            If h(5) = "8" And (gem0(2) <> "1" And gem0(2) <> "4" And gem0(2) <> "3") Then tainted = 1
                        Else
                            tainted = 1
                        End If
                    End If
                    If h(6) <> "" And h(6) <> "0" Then
                        If gemIDs(1) <> "0" Then
                            ' Get the color of the gem from it's ID, second socket
                            Dim gem1() As String = Split(Variables.GemHash_Id(gemIDs(1)), ";")
                            If h(6) = 2 And (gem1(2) <> "0" And gem1(2) <> "5" And gem1(2) <> "3") Then tainted = 1
                            If h(6) = 4 And (gem1(2) <> "2" And gem1(2) <> "5" And gem1(2) <> "4") Then tainted = 1
                            If h(6) = 8 And (gem1(2) <> "1" And gem1(2) <> "4" And gem1(2) <> "3") Then tainted = 1
                        Else
                            tainted = 1
                        End If
                    End If
                    If h(7) <> "" And h(7) <> "0" Then
                        If gemIDs(2) <> "0" Then
                            ' Get the color of the gem from it's ID, third socket
                            Dim gem2() As String = Split(Variables.GemHash_Id(gemIDs(2)), ";")
                            If h(7) = 2 And (gem2(2) <> "0" And gem2(2) <> "5" And gem2(2) <> "3") Then tainted = 1
                            If h(7) = 4 And (gem2(2) <> "2" And gem2(2) <> "5" And gem2(2) <> "4") Then tainted = 1
                            If h(7) = 8 And (gem2(2) <> "1" And gem2(2) <> "4" And gem2(2) <> "3") Then tainted = 1
                        Else
                            tainted = 1
                        End If
                    End If
                    ' If the slot colors match, add the socket bonus in.
                    If tainted = 0 Then
                        Dim sb() As String = Split(Variables.SocketBonus_Id.Item(h(8)), ";")
                        If sb(3) <> "0" Then Variables.SPFromGear += sb(3)
                        If sb(4) <> "0" Then Variables.CritFromGear += sb(4)
                        If sb(5) <> "0" Then Variables.HitFromGear += sb(5)
                        If sb(6) <> "0" Then Variables.HasteFromGear += sb(6)
                        If sb(7) <> "0" Then Variables.IntFromGear += sb(7)
                    End If
                End If
            End If
        Next

        For Each item In Variables.CurrentGems
            Dim s() As String = Split(item.Value, ";")
            Dim gem As String = ""
            For Each gem In s
                If gem <> "0" And gem <> "" Then
                    Dim h() As String = Split(Variables.GemHash_Id.Item(gem), ";")
                    If h(3) <> "" Then Variables.SPFromGear += h(3)
                    If h(4) <> "" Then Variables.CritFromGear += h(4)
                    If h(5) <> "" Then Variables.HitFromGear += h(5)
                    If h(6) <> "" Then Variables.HasteFromGear += h(6)
                    If h(7) <> "" Then Variables.IntFromGear += h(7)
                End If
            Next
        Next

        For Each item In Variables.CurrentEnchants
            If item.Value <> "0" And item.Value <> "" And item.Value <> "1230012" Then
                Dim h() As String = Split(item.Value, ";")
                If h(3) <> "" Then Variables.SPFromGear += h(3)
                If h(4) <> "" Then Variables.CritFromGear += h(4)
                If h(5) <> "" Then Variables.HitFromGear += h(5)
                If h(6) <> "" Then Variables.HasteFromGear += h(6)
                If h(7) <> "" Then Variables.IntFromGear += h(7)
            End If
        Next
    End Sub

    Private Function Char2WowSlot(ByVal slot As String) As String
        Dim result As String = slot
        Select Case slot
            Case "0"
                result = "1"
            Case "1"
                result = "2"
            Case "2"
                result = "3"
            Case "3"
                result = "4"
            Case "4"
                result = "5"
            Case "5"
                result = "6"
            Case "6"
                result = "7"
            Case "7"
                result = "8"
            Case "8"
                result = "9"
            Case "9"
                result = "10"
            Case "10"
                result = "11"
            Case "11"
                result = "11"
            Case "12"
                result = "12"
            Case "13"
                result = "12"
            Case "14"
                result = "16"
            Case "15"
                result = "13"
            Case "16"
                result = "14"
            Case "17"
                result = "28"
            Case "18"
                result = "19"
        End Select
        Return result
    End Function
End Module

' Notes
' Socket 1 = Meta
' Socket 2 = Red
' Socket 4 = Yellow
' Socket 8 = Blue

' Wowhead Slots
' 1  = Head
' 2  = Neck
' 3  = Shoulders
' 5  = Chest
' 6  = Waist
' 7  = Legs
' 8  = Feet
' 9  = Wrist
' 10 = Hands
' 11 = Finger
' 12 = Trinket
' 13 = One-Handed
' 14 = Shield
' 16 = Back
' 17 = Two-Handed
' 20 = Chest?
' 21 = Mainhand ONLY
' 23 = Offhand ONLY
' 28 = Relic

' CharSheet Slots
' 0 = Head
' 1 = Neck
' 2 = Shoulder
' 3 = Shirt
' 4 = Chest
' 5 = Waist
' 6 = Legs
' 7 = Feet
' 8 = Wrist
' 9 = Hands
' 10 = Finger 1
' 11 = Figner 2
' 12 = Trinket 1
' 13 = Trinket 2
' 14 = Back
' 15 = Mainhand
' 16 = Offhand
' 17 = Relic
' 18 = Tabard

' Talent Layout
'0         1         2         3         4
'01234567890123456789012345678901234567890
'553000150321335132501351005050031000000000000000000000000000000000000000000000
' 3.1.0:
' 01 = Convection
' 02 = Concussion
' 03 = Call of Flame
' 04 = Elemental Warding
' 05 = Elemental Devastation
' 06 = Reverberation
' 07 = Elemental Focus
' 08 = Elemental Fury
' 09 = Improved Fire Nova Totem
' 10 = Eye of the Storm
' 11 = Elemental Reach
' 12 = Call of Thunder
' 13 = Unrelenting Storm
' 14 = Elemental Precision
' 15 = Lightning Mastery
' 16 = Elemental Mastery
' 17 = Storm, Earth and Fire
' 18 = Booming Echoes
' 19 = Elemental Oath
' 20 = Lighting Overload
' 21 = Astral Shift
' 22 = Totem of Wrath
' 23 = Lava Flows
' 24 = Shamanism
' 25 = Thunderstorm
' 26 = Enhancing Totems
' 27 = Earth's Grasp
' 28 = Ancestral Knowledge
' 29 = Guardian Totems
' 30 = Thundering Strikes
' 31 = Improved Ghost Wolf
' 32 = Improved Shields
' 33 = Elemental Weapons
' 34 = Shamanistic Focus
