﻿Imports System.IO

Module DataFiles
    Public Sub LoadCharacterData()
        Dim ver As String = My.Application.Info.Version.ToString
        Variables.LoadDisable = True
        Try
            Dim result As DialogResult = Form1.LoadChar.ShowDialog()
            If result = DialogResult.OK Then
                Variables.CurrentGear.Clear()
                Variables.CurrentGems.Clear()
                Variables.CurrentEnchants.Clear()
                Variables.GearSetHash.Clear()
                Dim rawfile() As String = File.ReadAllLines(Form1.LoadChar.FileName)
                Dim fileVersion As String = rawfile(0) ' Save file version
                If ver <> fileVersion Then
                    MessageBox.Show("Save file is outdated.  Loading what I can.  Check your options and save the data." & vbCrLf _
                                    & "Check the Results tab for errors." & vbCrLf _
                                    & "Consider importing your character fresh.")
                End If

                Dim r0() As String = Split(rawfile(1), ",") ' Basic Character Info
                Dim r1() As String = Split(rawfile(2), ",") ' Talents
                Dim r2() As String = Split(rawfile(3), ",") ' Combat Options

                ' Line 2: Basic Info
                Try
                    Form1.CharSelect.Text = r0(0)
                    Form1.RealmSelect.Text = Replace(r0(1), "_", " ")
                    Form1.RaceSelect.Text = r0(2)
                    Form1.ShamanLevel.Text = r0(3)
                    Form1.ZoneSelect.Text = r0(4)
                Catch
                    Form1.TextBox1.AppendText("Failed to load basic info." & vbCrLf)
                End Try

                ' Line 3: Talents
                Try
                    Form1.Concussion.Text = r1(0)
                    Form1.CallofFlame.Text = r1(1)
                    Form1.ElementalFury.Text = r1(2)
                    If r1(3) = "1" Then Form1.CallofThunder.Checked = True Else Form1.CallofThunder.Checked = False
                    Form1.ElementalPrecision.Text = r1(4)
                    Form1.ElementalOath.Text = r1(5)
                    Form1.LightningOverload.Text = r1(6)
                    Form1.ThunderingStrikes.Text = r1(7)
                    Form1.LavaFlows.Text = r1(8)
                    Form1.Shamanism.Text = r1(9)
                    Form1.ElementalWeapons.Text = r1(10)
                    Form1.AncestralKnowledge.Text = r1(11)
                    Form1.StormEarthFire.Text = r1(12)
                    Form1.BoomingEchoes.Text = r1(13)

                    If r1(14) = "1" Then Form1.FlameTongueWeapon.Checked = True Else Form1.FlameTongueWeapon.Checked = False
                    If r1(15) = "1" Then Form1.TotemofWrath.Checked = True Else Form1.TotemofWrath.Checked = False
                    If r1(16) = "1" Then Form1.WrathofAir.Checked = True Else Form1.WrathofAir.Checked = False
                    If r1(17) = "1" Then Form1.CurseofElements.Checked = True Else Form1.CurseofElements.Checked = False
                    If r1(18) = "1" Then Form1.EbonPlaguebringer.Checked = True Else Form1.EbonPlaguebringer.Checked = False
                    If r1(19) = "1" Then Form1.WintersChill.Checked = True Else Form1.WintersChill.Checked = False
                    If r1(20) = "1" Then Form1.ImpFaerieFire.Checked = True Else Form1.ImpFaerieFire.Checked = False
                    If r1(21) = "1" Then Form1.ImpMoonkinAura.Checked = True Else Form1.ImpMoonkinAura.Checked = False
                    If r1(22) = "1" Then Form1.Heroism.Checked = True Else Form1.Heroism.Checked = False
                    If r1(23) = "1" Then Form1.GoFTWCheckBox.Checked = True Else Form1.GoFTWCheckBox.Checked = False
                    If r1(24) = "1" Then Form1.GoLCheckBox.Checked = True Else Form1.GoLCheckBox.Checked = False
                    If r1(25) = "1" Then Form1.GoLBCheckBox.Checked = True Else Form1.GoLBCheckBox.Checked = False
                    If r1(26) = "1" Then Form1.GoToWCheckBox.Checked = True Else Form1.GoToWCheckBox.Checked = False
                    'If r1(27) = "1" Then Form1.GoFSCheckBox.Checked = True Else Form1.GoFSCheckBox.Checked = False
                Catch
                    Form1.TextBox1.AppendText("Failed to load talent info." & vbCrLf)
                End Try

                ' Line 4: Combat Options
                Try
                    Form1.CycleSelect.Text = r2(0)
                    If r2(1) = "1" Then Form1.doModel.Checked = True Else Form1.doModel.Checked = False
                    Form1.FightLength.Text = r2(2)
                    Form1.MobLevel.Text = r2(3)
                    Form1.AddSpellDmg.Text = r2(4)
                    Form1.AddCritPerc.Text = r2(5)
                    Form1.AddCritRate.Text = r2(6)
                    Form1.AddHitRate.Text = r2(7)
                    Form1.AddHasteRate.Text = r2(8)
                    ' Elemental Oath was here.
                    Form1.ClearcastUptime.Text = r2(10)
                    Variables.StoredLBCast = CDec(r2(11))
                    Variables.StoredCLCast = CDec(r2(12))
                    Variables.StoredLvBCast = CDec(r2(13))
                    Variables.StoredFSGCD = CDec(r2(14))
                    Form1.DefBlueGem.Text = r2(15)
                    Form1.DefYellowGem.Text = r2(16)
                    Form1.DefRedGem.Text = r2(17)
                    Form1.DefMetaGem.Text = r2(18)
                    Form1.Latency.Text = r2(19)
                    Form1.instaLatency.Text = r2(20)
                Catch
                    Form1.TextBox1.AppendText("Failed to load combat info." & vbCrLf)
                End Try

                Try
                    ' Line 5+: Gear (Only first set (Read: line) is processed, all other sets are put inside GearSetHash hashtable.)
                    If UBound(rawfile) >= 4 Then
                        Dim r3() As String = Split(rawfile(4).Replace(" ", ""), ".") ' Gear Set 1
                        Dim r30() As String = Split(r3(0), ",") ' Items
                        Dim r31() As String = Split(r3(1), ",") ' Gems
                        Dim r32() As String = Split(r3(2), ",") ' Enchants
                        Variables.GearSetHash.Item(r30(0)) = rawfile(4)
                        Form1.SetCombo.Text = r30(0)
                        Form1.SetCombo.Items.Add(r30(0))
                        Form1.HeadCombo.Text = getItemNameFromId(r30(1))
                        getItemfromTextbox("Head", Form1.HeadCombo.Text)
                        Form1.NeckCombo.Text = getItemNameFromId(r30(2))
                        getItemfromTextbox("Neck", Form1.NeckCombo.Text)
                        Form1.ShouldersCombo.Text = getItemNameFromId(r30(3))
                        getItemfromTextbox("Shoulder", Form1.ShouldersCombo.Text)
                        Form1.BackCombo.Text = getItemNameFromId(r30(4))
                        getItemfromTextbox("Back", Form1.BackCombo.Text)
                        Form1.ChestCombo.Text = getItemNameFromId(r30(5))
                        getItemfromTextbox("Chest", Form1.ChestCombo.Text)
                        Form1.WristCombo.Text = getItemNameFromId(r30(6))
                        getItemfromTextbox("Wrist", Form1.WristCombo.Text)
                        Form1.MainHandCombo.Text = getItemNameFromId(r30(7))
                        getItemfromTextbox("MainHand", Form1.MainHandCombo.Text)
                        Form1.OffHandCombo.Text = getItemNameFromId(r30(8))
                        getItemfromTextbox("OffHand", Form1.OffHandCombo.Text)
                        Form1.RelicCombo.Text = getItemNameFromId(r30(9))
                        getItemfromTextbox("Relic", Form1.RelicCombo.Text)
                        Form1.HandsCombo.Text = getItemNameFromId(r30(10))
                        getItemfromTextbox("Hands", Form1.HandsCombo.Text)
                        Form1.WaistCombo.Text = getItemNameFromId(r30(11))
                        getItemfromTextbox("Waist", Form1.WaistCombo.Text)
                        Form1.LegsCombo.Text = getItemNameFromId(r30(12))
                        getItemfromTextbox("Legs", Form1.LegsCombo.Text)
                        Form1.FeetCombo.Text = getItemNameFromId(r30(13))
                        getItemfromTextbox("Feet", Form1.FeetCombo.Text)
                        Form1.Finger1Combo.Text = getItemNameFromId(r30(14))
                        getItemfromTextbox("Finger1", Form1.Finger1Combo.Text)
                        Form1.Finger2Combo.Text = getItemNameFromId(r30(15))
                        getItemfromTextbox("Finger2", Form1.Finger2Combo.Text)
                        Form1.Trinket1Combo.Text = getItemNameFromId(r30(16))
                        getItemfromTextbox("Trinket1", Form1.Trinket1Combo.Text)
                        Form1.Trinket2Combo.Text = getItemNameFromId(r30(17))
                        getItemfromTextbox("Trinket2", Form1.Trinket2Combo.Text)
                        ' Gems
                        Variables.CurrentGems.Add("Head", r31(0))
                        Variables.CurrentGems.Add("Neck", r31(1))
                        Variables.CurrentGems.Add("Shoulder", r31(2))
                        Variables.CurrentGems.Add("Back", r31(3))
                        Variables.CurrentGems.Add("Chest", r31(4))
                        Variables.CurrentGems.Add("Wrist", r31(5))
                        Variables.CurrentGems.Add("MainHand", r31(6))
                        Variables.CurrentGems.Add("OffHand", r31(7))
                        Variables.CurrentGems.Add("Relic", r31(8))
                        Variables.CurrentGems.Add("Hands", r31(9))
                        Variables.CurrentGems.Add("Waist", r31(10))
                        Variables.CurrentGems.Add("Legs", r31(11))
                        Variables.CurrentGems.Add("Feet", r31(12))
                        Variables.CurrentGems.Add("Finger1", r31(13))
                        Variables.CurrentGems.Add("Finger2", r31(14))
                        Variables.CurrentGems.Add("Trinket1", r31(15))
                        Variables.CurrentGems.Add("Trinket2", r31(16))
                        ' Enchants
                        Variables.CurrentEnchants.Add("Head", getEnchantInfo(r32(0), 1))
                        Variables.CurrentEnchants.Add("Neck", getEnchantInfo(r32(1), 1))
                        Variables.CurrentEnchants.Add("Shoulder", getEnchantInfo(r32(2), 1))
                        Variables.CurrentEnchants.Add("Back", getEnchantInfo(r32(3), 1))
                        Variables.CurrentEnchants.Add("Chest", getEnchantInfo(r32(4), 1))
                        Variables.CurrentEnchants.Add("Wrist", getEnchantInfo(r32(5), 1))
                        Variables.CurrentEnchants.Add("MainHand", getEnchantInfo(r32(6), 1))
                        Variables.CurrentEnchants.Add("OffHand", getEnchantInfo(r32(7), 1))
                        Variables.CurrentEnchants.Add("Relic", getEnchantInfo(r32(8), 1))
                        Variables.CurrentEnchants.Add("Hands", getEnchantInfo(r32(9), 1))
                        Variables.CurrentEnchants.Add("Waist", getEnchantInfo(r32(10), 1))
                        Variables.CurrentEnchants.Add("Legs", getEnchantInfo(r32(11), 1))
                        Variables.CurrentEnchants.Add("Feet", getEnchantInfo(r32(12), 1))
                        Variables.CurrentEnchants.Add("Finger1", getEnchantInfo(r32(13), 1))
                        Variables.CurrentEnchants.Add("Finger2", getEnchantInfo(r32(14), 1))
                        Variables.CurrentEnchants.Add("Trinket1", getEnchantInfo(r32(15), 1))
                        Variables.CurrentEnchants.Add("Trinket2", getEnchantInfo(r32(16), 1))
                    End If

                    If UBound(rawfile) > 4 Then
                        ' Load the other sets into the GearSetHash.
                        Dim i As Integer = 0
                        For i = 5 To rawfile.Count - 1
                            Dim tempi() As String = Split(rawfile(i), ",")
                            If rawfile(i) <> "" Then
                                rawfile(i).Replace(" ", "")
                                Variables.GearSetHash.Item(tempi(0)) = rawfile(i)
                                Form1.SetCombo.Items.Add(tempi(0))
                            End If
                        Next
                    End If
                Catch
                    Form1.TextBox1.AppendText("Failed to load gear info." & vbCrLf)
                End Try
            End If
        Catch ex As Exception
            MessageBox.Show("Error loading character data." & vbCrLf & "Details in result tab.")
            Form1.TextBox1.AppendText(ex.Message & vbCrLf)
        End Try
        Variables.LoadDisable = False
    End Sub

    Public Sub SaveCharacterData()
        ' Write all char level, race, gear, gems, and talents to a data file.
        Dim name As String = Form1.CharSelect.Text
        Dim realm As String = Form1.RealmSelect.Text
        realm = Replace(realm, " ", "_")
        Dim charfile As String = "Data\Characters\" & name & "-" & realm & ".char"
        Dim output As String = ""
        ' Delete existing char file.
        If File.Exists(charfile) Then File.Delete(charfile)
        ' Line 1: Version information
        output = My.Application.Info.Version.ToString
        output &= vbCrLf
        ' Line 2: Compose Character Info
        output &= name & ","
        output &= realm & ","
        output &= Form1.RaceSelect.Text & ","
        output &= Form1.ShamanLevel.Text & ","
        output &= Form1.ZoneSelect.Text
        output &= vbCrLf
        ' Line 3: Compose Character Talent & Buff Info
        output &= Form1.Concussion.Text & ","
        output &= Form1.CallofFlame.Text & ","
        output &= Form1.ElementalFury.Text & ","
        If Form1.CallofThunder.Checked Then output &= "1," Else output &= "0,"
        output &= Form1.ElementalPrecision.Text & ","
        output &= Form1.ElementalOath.Text & ","
        output &= Form1.LightningOverload.Text & ","
        output &= Form1.ThunderingStrikes.Text & ","
        output &= Form1.LavaFlows.Text & ","
        output &= Form1.Shamanism.Text & ","
        output &= Form1.ElementalWeapons.Text & ","
        output &= Form1.AncestralKnowledge.Text & ","
        output &= Form1.StormEarthFire.Text & ","
        output &= Form1.BoomingEchoes.Text & ","
        If Form1.FlameTongueWeapon.Checked Then output &= "1," Else output &= "0,"
        If Form1.TotemofWrath.Checked Then output &= "1," Else output &= "0,"
        If Form1.WrathofAir.Checked Then output &= "1," Else output &= "0,"
        If Form1.CurseofElements.Checked Then output &= "1," Else output &= "0,"
        If Form1.EbonPlaguebringer.Checked Then output &= "1," Else output &= "0,"
        If Form1.WintersChill.Checked Then output &= "1," Else output &= "0,"
        If Form1.ImpFaerieFire.Checked Then output &= "1," Else output &= "0,"
        If Form1.ImpMoonkinAura.Checked Then output &= "1," Else output &= "0,"
        If Form1.Heroism.Checked Then output &= "1," Else output &= "0,"
        If Form1.GoFTWCheckBox.Checked Then output &= "1," Else output &= "0,"
        If Form1.GoLCheckBox.Checked Then output &= "1," Else output &= "0,"
        If Form1.GoLBCheckBox.Checked Then output &= "1," Else output &= "0,"
        If Form1.GoToWCheckBox.Checked Then output &= "1," Else output &= "0"
        'If Form1.GoFSCheckBox.Checked Then output &= "1" Else output &= "0"

        output &= vbCrLf
        ' Line 4: Compose Combat Options.
        output &= Form1.CycleSelect.Text & ","
        If Form1.doModel.Checked Then output &= "1," Else output &= "0,"
        output &= Form1.FightLength.Text & ","
        output &= Form1.MobLevel.Text & ","
        output &= Form1.AddSpellDmg.Text & ","
        output &= Form1.AddCritPerc.Text & ","
        output &= Form1.AddCritRate.Text & ","
        output &= Form1.AddHitRate.Text & ","
        output &= Form1.AddHasteRate.Text & ","
        output &= "0," ' This was Elemental Oath
        output &= Form1.ClearcastUptime.Text & ","
        output &= Variables.StoredLBCast & ","
        output &= Variables.StoredCLCast & ","
        output &= Variables.StoredLvBCast & ","
        output &= Variables.StoredFSGCD & ","
        output &= Form1.DefBlueGem.Text & ","
        output &= Form1.DefYellowGem.Text & ","
        output &= Form1.DefRedGem.Text & ","
        output &= Form1.DefMetaGem.Text & ","
        output &= Form1.Latency.Text & ","
        output &= Form1.instaLatency.Text
        output &= vbCrLf

        ' Line 5+: Compose Gear Sets
        ' First, process the current set, then loop through the Hashtable for the other sets.
        ' Items
        Dim activeSet As String = ""
        If Form1.SetCombo.Text = "" Then activeSet &= "Default" Else activeSet &= Form1.SetCombo.Text
        output &= activeSet & ","
        output &= getItemIDFromName(Form1.HeadCombo.Text) & ","
        output &= getItemIDFromName(Form1.NeckCombo.Text) & ","
        output &= getItemIDFromName(Form1.ShouldersCombo.Text) & ","
        output &= getItemIDFromName(Form1.BackCombo.Text) & ","
        output &= getItemIDFromName(Form1.ChestCombo.Text) & ","
        output &= getItemIDFromName(Form1.WristCombo.Text) & ","
        output &= getItemIDFromName(Form1.MainHandCombo.Text) & ","
        output &= getItemIDFromName(Form1.OffHandCombo.Text) & ","
        output &= getItemIDFromName(Form1.RelicCombo.Text) & ","
        output &= getItemIDFromName(Form1.HandsCombo.Text) & ","
        output &= getItemIDFromName(Form1.WaistCombo.Text) & ","
        output &= getItemIDFromName(Form1.LegsCombo.Text) & ","
        output &= getItemIDFromName(Form1.FeetCombo.Text) & ","
        output &= getItemIDFromName(Form1.Finger1Combo.Text) & ","
        output &= getItemIDFromName(Form1.Finger2Combo.Text) & ","
        output &= getItemIDFromName(Form1.Trinket1Combo.Text) & ","
        output &= getItemIDFromName(Form1.Trinket2Combo.Text) & "."
        ' Gems.
        output &= Variables.CurrentGems.Item("Head") & ","
        output &= Variables.CurrentGems.Item("Neck") & ","
        output &= Variables.CurrentGems.Item("Shoulder") & ","
        output &= Variables.CurrentGems.Item("Back") & ","
        output &= Variables.CurrentGems.Item("Chest") & ","
        output &= Variables.CurrentGems.Item("Wrist") & ","
        output &= Variables.CurrentGems.Item("MainHand") & ","
        output &= Variables.CurrentGems.Item("OffHand") & ","
        output &= Variables.CurrentGems.Item("Relic") & ","
        output &= Variables.CurrentGems.Item("Hands") & ","
        output &= Variables.CurrentGems.Item("Waist") & ","
        output &= Variables.CurrentGems.Item("Legs") & ","
        output &= Variables.CurrentGems.Item("Feet") & ","
        output &= Variables.CurrentGems.Item("Finger1") & ","
        output &= Variables.CurrentGems.Item("Finger2") & ","
        output &= Variables.CurrentGems.Item("Trinket1") & ","
        output &= Variables.CurrentGems.Item("Trinket2") & "."
        ' Enchants.
        output &= getEnchantInfo(Variables.CurrentEnchants.Item("Head"), 0) & ","
        output &= getEnchantInfo(Variables.CurrentEnchants.Item("Neck"), 0) & ","
        output &= getEnchantInfo(Variables.CurrentEnchants.Item("Shoulder"), 0) & ","
        output &= getEnchantInfo(Variables.CurrentEnchants.Item("Back"), 0) & ","
        output &= getEnchantInfo(Variables.CurrentEnchants.Item("Chest"), 0) & ","
        output &= getEnchantInfo(Variables.CurrentEnchants.Item("Wrist"), 0) & ","
        output &= getEnchantInfo(Variables.CurrentEnchants.Item("MainHand"), 0) & ","
        output &= getEnchantInfo(Variables.CurrentEnchants.Item("OffHand"), 0) & ","
        output &= getEnchantInfo(Variables.CurrentEnchants.Item("Relic"), 0) & ","
        output &= getEnchantInfo(Variables.CurrentEnchants.Item("Hands"), 0) & ","
        output &= getEnchantInfo(Variables.CurrentEnchants.Item("Waist"), 0) & ","
        output &= getEnchantInfo(Variables.CurrentEnchants.Item("Legs"), 0) & ","
        output &= getEnchantInfo(Variables.CurrentEnchants.Item("Feet"), 0) & ","
        output &= getEnchantInfo(Variables.CurrentEnchants.Item("Finger1"), 0) & ","
        output &= getEnchantInfo(Variables.CurrentEnchants.Item("Finger2"), 0) & ","
        output &= getEnchantInfo(Variables.CurrentEnchants.Item("Trinket1"), 0) & ","
        output &= getEnchantInfo(Variables.CurrentEnchants.Item("Trinket2"), 0)
        output &= vbCrLf

        ' Write out the rest of the stored sets.
        Dim setItem As DictionaryEntry
        For Each setItem In Variables.GearSetHash
            If setItem.Key <> activeSet Then
                If setItem.Value <> "" Then output &= setItem.Value & vbCrLf
            End If
        Next

        Dim objWriter As New System.IO.StreamWriter(charfile, True)
        objWriter.WriteLine(output)
        objWriter.Close()
    End Sub

    Public Sub CheckDirs()
        ' Parent Data directory.
        Try
            If Not Directory.Exists("Data") Then
                Directory.CreateDirectory("Data")
            End If
            ' Character Data Directory.
            If Not Directory.Exists("Data\Characters") Then
                Directory.CreateDirectory("Data\Characters")
            End If
        Catch ex As Exception
            MessageBox.Show("Unable to create Data directories: " & ex.Message)
        End Try
    End Sub

    Public Sub loadGearData()
        Try
            If File.Exists("Data\gear.data") Then
                Dim rawfile() As String = File.ReadAllLines("Data\gear.data")
                For Each line In rawfile
                    Dim sl() As String = Split(line, ";")
                    If UBound(sl) > 0 Then
                        If sl(0) = "1" Then
                            Variables.HeadArray.Add(sl(1), line)
                            Variables.AllItemsArray_Name.Add(sl(2), line)
                            Variables.AllItemsArray_Id.Add(sl(1), line)
                            Form1.HeadCombo.Items.Add(sl(2))
                        ElseIf sl(0) = "2" Then
                            Variables.NeckArray.Add(sl(1), line)
                            Variables.AllItemsArray_Name.Add(sl(2), line)
                            Variables.AllItemsArray_Id.Add(sl(1), line)
                            Form1.NeckCombo.Items.Add(sl(2))
                        ElseIf sl(0) = "3" Then
                            Variables.ShoulderArray.Add(sl(1), line)
                            Variables.AllItemsArray_Name.Add(sl(2), line)
                            Variables.AllItemsArray_Id.Add(sl(1), line)
                            Form1.ShouldersCombo.Items.Add(sl(2))
                        ElseIf sl(0) = "5" Then
                            Variables.ChestArray.Add(sl(1), line)
                            Variables.AllItemsArray_Name.Add(sl(2), line)
                            Variables.AllItemsArray_Id.Add(sl(1), line)
                            Form1.ChestCombo.Items.Add(sl(2))
                        ElseIf sl(0) = "6" Then
                            Variables.WaistArray.Add(sl(1), line)
                            Variables.AllItemsArray_Name.Add(sl(2), line)
                            Variables.AllItemsArray_Id.Add(sl(1), line)
                            Form1.WaistCombo.Items.Add(sl(2))
                        ElseIf sl(0) = "7" Then
                            Variables.LegsArray.Add(sl(1), line)
                            Variables.AllItemsArray_Name.Add(sl(2), line)
                            Variables.AllItemsArray_Id.Add(sl(1), line)
                            Form1.LegsCombo.Items.Add(sl(2))
                        ElseIf sl(0) = "8" Then
                            Variables.FeetArray.Add(sl(1), line)
                            Variables.AllItemsArray_Name.Add(sl(2), line)
                            Variables.AllItemsArray_Id.Add(sl(1), line)
                            Form1.FeetCombo.Items.Add(sl(2))
                        ElseIf sl(0) = "9" Then
                            Variables.WristArray.Add(sl(1), line)
                            Variables.AllItemsArray_Name.Add(sl(2), line)
                            Variables.AllItemsArray_Id.Add(sl(1), line)
                            Form1.WristCombo.Items.Add(sl(2))
                        ElseIf sl(0) = "10" Then
                            Variables.HandsArray.Add(sl(1), line)
                            Variables.AllItemsArray_Name.Add(sl(2), line)
                            Variables.AllItemsArray_Id.Add(sl(1), line)
                            Form1.HandsCombo.Items.Add(sl(2))
                        ElseIf sl(0) = "11" Then
                            Variables.FingerArray.Add(sl(1), line)
                            Variables.AllItemsArray_Name.Add(sl(2), line)
                            Variables.AllItemsArray_Id.Add(sl(1), line)
                            Form1.Finger1Combo.Items.Add(sl(2))
                            Form1.Finger2Combo.Items.Add(sl(2))
                        ElseIf sl(0) = "12" Then
                            Variables.TrinketArray.Add(sl(1), line)
                            Variables.AllItemsArray_Name.Add(sl(2), line)
                            Variables.AllItemsArray_Id.Add(sl(1), line)
                            Form1.Trinket1Combo.Items.Add(sl(2))
                            Form1.Trinket2Combo.Items.Add(sl(2))
                        ElseIf sl(0) = "13" Or sl(0) = "17" Or sl(0) = "21" Then ' Mainhand
                            Variables.MainHandArray.Add(sl(1), line)
                            Variables.AllItemsArray_Name.Add(sl(2), line)
                            Variables.AllItemsArray_Id.Add(sl(1), line)
                            Form1.MainHandCombo.Items.Add(sl(2))
                        ElseIf sl(0) = "14" Or sl(0) = "23" Then ' Offhand
                            Variables.OffHandArray.Add(sl(1), line)
                            Variables.AllItemsArray_Name.Add(sl(2), line)
                            Variables.AllItemsArray_Id.Add(sl(1), line)
                            Form1.OffHandCombo.Items.Add(sl(2))
                        ElseIf sl(0) = "16" Then
                            Variables.BackArray.Add(sl(1), line)
                            Variables.AllItemsArray_Name.Add(sl(2), line)
                            Variables.AllItemsArray_Id.Add(sl(1), line)
                            Form1.BackCombo.Items.Add(sl(2))
                        ElseIf sl(0) = "20" Then ' Another chestpiece
                            Variables.ChestArray.Add(sl(1), line)
                            Variables.AllItemsArray_Name.Add(sl(2), line)
                            Variables.AllItemsArray_Id.Add(sl(1), line)
                            Form1.ChestCombo.Items.Add(sl(2))
                        ElseIf sl(0) = "28" Then ' Relic
                            Variables.RelicArray.Add(sl(1), line)
                            Variables.AllItemsArray_Name.Add(sl(2), line)
                            Variables.AllItemsArray_Id.Add(sl(1), line)
                            Form1.RelicCombo.Items.Add(sl(2))
                        Else
                            ' Slot 20 caught me off guard, let's try to avoid that again.
                            Form1.TextBox1.AppendText("Unknown item: " & line & vbCrLf)
                        End If
                    End If
                Next
                Form1.sortGearDropDown()
            End If
        Catch ex As Exception
            MessageBox.Show("Error loading item: " & ex.Message)
        End Try
    End Sub

    Public Sub loadEnchantData()
        ' ID;Name;Slot;SP;Crit;Hit;Haste;Int;Stam
        Dim i As Integer = 0
        Try
            If File.Exists("Data\enchants.data") Then
                Dim rawfile() As String = File.ReadAllLines("Data\enchants.data")
                For Each line In rawfile
                    Dim sl() As String = Split(line, ";")
                    If UBound(sl) > 0 Then
                        Variables.EnchantHash_Id.Add(sl(0), line)
                        Variables.EnchantHash_Name.Add(sl(1), line)
                    End If
                Next
            End If
        Catch ex As Exception
            MessageBox.Show("Error loading enchant: " & ex.Message)
        End Try
    End Sub

    Public Sub loadGemData()
        ' ID;Name;Class;SP;Crit;Hit;Haste;Int;Stam;Hit Dmg;Crit Dmg - Class is which socket
        Try
            If File.Exists("Data\gem.data") Then
                Dim rawfile() As String = File.ReadAllLines("Data\gem.data")
                For Each line In rawfile
                    Dim sl() As String = Split(line, ";")
                    If UBound(sl) > 0 Then
                        Variables.GemHash_Id.Add(sl(0), line)
                        Variables.GemHash_Name.Add(sl(1), line)
                        If sl(2) = "0" Or sl(2) = "3" Or sl(2) = "5" Then
                            Form1.DefRedGem.Items.Add(sl(1))
                        End If
                        If sl(2) = "1" Or sl(2) = "3" Or sl(2) = "4" Then
                            Form1.DefBlueGem.Items.Add(sl(1))
                        End If
                        If sl(2) = "2" Or sl(2) = "4" Or sl(2) = "5" Then
                            Form1.DefYellowGem.Items.Add(sl(1))
                        End If
                        If sl(2) = "6" Then
                            Form1.DefMetaGem.Items.Add(sl(1))
                        End If
                    End If
                Next
            End If
        Catch ex As Exception
            MessageBox.Show("Error loading gem: " & ex.Message)
        End Try
    End Sub

    Public Sub loadSocketBonusData()
        ' ID;Item Seen;Info;SP;Crit;Hit;Haste;Int;Stam
        Try
            If File.Exists("Data\socketbonus.data") Then
                Dim rawfile() As String = File.ReadAllLines("Data\socketbonus.data")
                For Each line In rawfile
                    Dim sl() As String = Split(line, ";")
                    If UBound(sl) > 0 Then
                        Variables.SocketBonus_Id.Add(sl(0), line)
                        If Not Variables.SocketBonus_Name.ContainsKey(sl(2)) Then Variables.SocketBonus_Name.Add(sl(2), line)
                    End If
                Next
            End If
        Catch ex As Exception
            MessageBox.Show("Error loading socket bonus: " & ex.Message)
        End Try
    End Sub

    Public Function getItemIDFromName(ByVal itemname)
        Dim result As String = ""
        If itemname <> "" Then
            Dim rawstring As String = Variables.AllItemsArray_Name.Item(itemname)
            If rawstring <> "" Then
                Dim broken() As String = Split(rawstring, ";")
                If broken(1) <> "" Then result = Trim(broken(1))
            End If
        End If
        Return result
    End Function

    Public Function getItemNameFromId(ByVal itemid)
        Dim result As String = ""
        If itemid <> "" Then
            Dim rawstring As String = Variables.AllItemsArray_Id.Item(itemid)
            If rawstring <> "" Then
                Dim broken() As String = Split(rawstring, ";")
                If broken(2) <> "" Then result = Trim(broken(2))
            End If
        End If
        Return result
    End Function

    Public Function getEnchantInfo(ByVal value, ByVal method)
        Dim result As String = ""

        ' Belt Buckle enchant.
        If value = "1230012" Then
            Return "1230012"
            Exit Function
        End If

        If value = "" Or value = "0" Then
            Return result
            Exit Function
        End If

        If method = 0 Then
            ' Method 0: Getting the ID from the complete string.
            Dim s() As String = Split(value, ";")
            result = Trim(s(0))
        ElseIf method = 1 Then
            ' Method 1: Getting the complete string from the ID
            Dim item As DictionaryEntry
            For Each item In Variables.EnchantHash_Id
                Dim s() As String = Split(item.Value, ";")
                If s(0) = value Then
                    result = Trim(item.Value)
                    Exit For
                End If
            Next
        End If
        Return result
    End Function

    Public Sub getItemfromTextbox(ByVal slot, ByVal itemname)
        If slot <> "" And itemname <> "" Then
            Variables.CurrentGear.Add(slot, Variables.AllItemsArray_Name.Item(itemname))
        End If
    End Sub

    Public Sub clearItemArrays()
        Variables.AllItemsArray_Id.Clear()
        Variables.AllItemsArray_Name.Clear()
        Variables.EnchantHash_Id.Clear()
        Variables.EnchantHash_Name.Clear()
        Variables.GemHash_Id.Clear()
        Variables.GemHash_Name.Clear()
        Variables.HeadArray.Clear()
        Variables.NeckArray.Clear()
        Variables.ShoulderArray.Clear()
        Variables.ChestArray.Clear()
        Variables.WaistArray.Clear()
        Variables.LegsArray.Clear()
        Variables.FeetArray.Clear()
        Variables.WristArray.Clear()
        Variables.HandsArray.Clear()
        Variables.FingerArray.Clear()
        Variables.TrinketArray.Clear()
        Variables.BackArray.Clear()
        Variables.MainHandArray.Clear()
        Variables.OffHandArray.Clear()
        Variables.RelicArray.Clear()
    End Sub
End Module

' Notes
' Slot, Id, name, armor, set bonus, gem1, gem2, gem3, gem bonus, Int, Stam, Spell Damage, Hit, Crit, Haste, Display ID, Is Unique
' Wowhead Slots
' 1  = Head
' 2  = Neck
' 3  = Shoulders
' 6  = Waist
' 7  = Legs
' 8  = Feet
' 9  = Wrist
' 10 = Hands
' 11 = Finger
' 12 = Trinket
' 13 = One-Handed
' 14 = Shield
' 16 = Back
' 17 = Two-Handed
' 20 = Chest
' 21 = Mainhand ONLY
' 23 = Offhand ONLY
' 28 = Relic
