﻿Imports System.ComponentModel
Public Class ItemComparison

    Dim itemSlot As String = ""

    Private Sub ItemComparison_Shown(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Shown

    End Sub

    Private Sub StartButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles StartButton.Click
        If SlotCombo.Text <> "" Then
            StartButton.Enabled = False
            SlotCombo.Enabled = False
            DGV.Rows.Clear()
            itemSlot = SlotCombo.Text

            ' Store current values.
            Dim savedGear As String = Variables.CurrentGear.Item(itemSlot)
            Dim savedGem As String = Variables.CurrentGems.Item(itemSlot)

            ' Run a baseline DPS test.
            Other.doModelRun()
            Dim storedDPS As Integer = Other.parseTenResults

            ' Loop through available gear.
            Dim selHash As New Hashtable()
            selHash = getHashTable()
            Dim setItem As DictionaryEntry
            For Each setItem In selHash
                If setItem.Value <> savedGear Then
                    ' Set item as current gear.
                    Variables.CurrentGear.Item(itemSlot) = setItem.Value
                    ' Check for gems.
                    Dim gem0 As String = "0"
                    Dim gem1 As String = "0"
                    Dim gem2 As String = "0"
                    Dim h() As String = Split(setItem.Value, ";")
                    If h(5) <> "0" Or h(5) <> "" Then gem0 = getGem(h(5))
                    If h(6) <> "0" Or h(6) <> "" Then gem1 = getGem(h(6))
                    If h(7) <> "0" Or h(7) <> "" Then gem2 = getGem(h(7))
                    ' Set gems, or blank out if no sockets.
                    Variables.CurrentGems.Item(itemSlot) = gem0 & ";" & gem1 & ";" & gem2
                    ' Update gear/stats.
                    Armory.processGearInfo()
                    Form1.updateRatings()
                    Other.moveToStorageStats()
                    ' Run Model
                    Other.doModelRun()
                    ' Can use the TenBox result parser to get the DPS value.
                    Dim newdps As Integer = Other.parseTenResults()
                    Variables.rawDamage.Clear()

                    ' Difference from current DPS to comparision DPS.
                    Dim changedDPS As Integer = newdps - storedDPS

                    ' Break up item info. (Order for DGV: Name, DPS, SP, Crit, Haste, Hit)
                    Dim rItem As String() = Split(setItem.Value, ";")
                    ' Update the datagrid with values, if applicable.
                    If (UpgradeOnly.Checked = True And changedDPS > 0) Or UpgradeOnly.Checked = False Then
                        Dim sp As Integer = 0
                        Dim crit As Integer = 0
                        Dim haste As Integer = 0
                        Dim hit As Integer = 0
                        If rItem(11) <> "" Then sp = CInt(rItem(11))
                        If rItem(13) <> "" Then crit = CInt(rItem(13))
                        If rItem(14) <> "" Then haste = CInt(rItem(14))
                        If rItem(12) <> "" Then hit = CInt(rItem(12))
                        DGV.Rows.Add(rItem(2), changedDPS, sp, crit, haste, hit)
                    End If
                End If
            Next
            ' Reset current gear.
            Variables.CurrentGear.Item(itemSlot) = savedGear
            Variables.CurrentGems.Item(itemSlot) = savedGem
            ' Process original gear at the end.
            Armory.processGearInfo()
            Form1.updateRatings()
            Other.moveToStorageStats()
            StartButton.Enabled = True
            SlotCombo.Enabled = True
        End If
    End Sub

    Private Sub ICCloseButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ICCloseButton.Click
        Me.Close()
    End Sub

    Private Function getHashTable() As Hashtable
        Dim result As New Hashtable
        Select Case itemSlot
            Case "Head"
                result = Variables.HeadArray
            Case "Neck"
                result = Variables.NeckArray
            Case "Shoulder"
                result = Variables.ShoulderArray
            Case "Back"
                result = Variables.BackArray
            Case "Chest"
                result = Variables.ChestArray
            Case "Wrist"
                result = Variables.WristArray
            Case "MainHand"
                result = Variables.MainHandArray
            Case "OffHand"
                result = Variables.OffHandArray
            Case "Hands"
                result = Variables.HandsArray
            Case "Waist"
                result = Variables.WaistArray
            Case "Legs"
                result = Variables.LegsArray
            Case "Feet"
                result = Variables.FeetArray
            Case "Finger1"
                result = Variables.FingerArray
            Case "Finger2"
                result = Variables.FingerArray
            Case "Trinket1"
                result = Variables.TrinketArray
            Case "Trinket2"
                result = Variables.TrinketArray
        End Select
        Return result
    End Function

    Private Function getGem(ByVal color As String) As String
        Dim result As String = "0"
        Select Case color
            Case "1"
                result = Variables.StoredDefMetaGem
            Case "2"
                result = Variables.StoredDefRedGem
            Case "4"
                result = Variables.StoredDefYellowGem
            Case "8"
                result = Variables.StoredDefBlueGem
        End Select
        Return result
    End Function
End Class


' Notes:
'               ' 0     1   2      3      4          5     6     7       8        9   10     11           12    13    14      15         16
'Items: 		' Slot, ID, name, armor, set bonus, gem1, gem2, gem3, gem bonus, Int, Stam, Spell Damage, Hit, Crit, Haste, Display ID, Is Unique

' Socket 1 = Meta
' Socket 2 = Red
' Socket 4 = Yellow
' Socket 8 = Blue