﻿Imports System.IO

Public Class ItemEditor_Enchants
    Private Sub ItemEditor_Gems_Shown(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Shown
        processComboBox()
    End Sub

    Private Sub EnchantComboBox_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles EnchantComboBox.SelectedIndexChanged
        Dim enchant() As String = Split(EnchantComboBox.Text, " ; ")
        Dim item() As String = Split(Variables.EnchantHash_Name.Item(enchant(0)), ";")
        IDTextBox.Text = item(0)
        NameTextBox.Text = item(1)
        SlotTextBox.Text = getSlotName(item(2))
        SpDmgTextBox.Text = item(3)
        CritTextBox.Text = item(4)
        HitTextBox.Text = item(5)
        HasteTextBox.Text = item(6)
        IntTextBox.Text = item(7)
        StamTextBox.Text = item(8)
    End Sub

    Private Sub EnchEditSaveButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles EnchEditSaveButton.Click
        If EnchantComboBox.Text <> "" Then
            Try
                ' Assemble new item string.
                Dim enchant() As String = Split(EnchantComboBox.Text, " ; ")
                Dim slot As String = getSlotID(SlotTextBox.Text)
                Dim newstring = IDTextBox.Text & ";" & NameTextBox.Text & ";" & slot & ";" & SpDmgTextBox.Text & ";" & CritTextBox.Text & ";" & _
                HitTextBox.Text & ";" & HasteTextBox.Text & ";" & IntTextBox.Text & ";" & StamTextBox.Text
                ' Update item array.
                Variables.EnchantHash_Name.Remove(enchant(0))
                Variables.EnchantHash_Name.Add(NameTextBox.Text, newstring)
                Variables.EnchantHash_Id(IDTextBox.Text) = newstring
                ' Rewrite item file.
                Dim objWriterArmor As New StreamWriter("data\enchants.data", False)
                For Each item In Variables.EnchantHash_Name
                    If item.value <> "" Then
                        objWriterArmor.WriteLine(item.value)
                    End If
                Next
                objWriterArmor.Close()
                processComboBox()
                MessageBox.Show("Enchant saved")
            Catch ex As Exception
                MessageBox.Show("Error while saving:" & vbCrLf & ex.Message)
            End Try
        End If
    End Sub

    Private Sub EnchEditDeleteButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles EnchEditDeleteButton.Click
        Try
            ' Delete from item array.
            Variables.EnchantHash_Name.Remove(EnchantComboBox.Text)
            Variables.EnchantHash_Id.Remove(IDTextBox.Text)
            ' Rewrite item file.
            Dim objWriterArmor As New StreamWriter("data\enchants.data", False)
            For Each item In Variables.EnchantHash_Name
                objWriterArmor.WriteLine(item.value)
            Next
            objWriterArmor.Close()
            processComboBox()
            MessageBox.Show("Enchant deleted")
        Catch ex As Exception
            MessageBox.Show("Error while deleting:" & vbCrLf & ex.Message)
        End Try
    End Sub

    Private Sub EnchEditCloseButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles EnchEditCloseButton.Click
        Me.Close()
    End Sub

    Private Function getSlotName(ByVal id As String) As String
        Dim result As String = id.ToString
        Select Case id
            Case "1"
                result = "Head"
            Case "2"
                result = "Neck"
            Case "3"
                result = "Shoulders"
            Case "4"
                result = "Shirt"
            Case "5"
                result = "Chest"
            Case "6"
                result = "Waist"
            Case "7"
                result = "Legs"
            Case "8"
                result = "Feet"
            Case "9"
                result = "Wrist"
            Case "10"
                result = "Hands"
            Case "11"
                result = "Finger"
            Case "12"
                result = "Trinket"
            Case "13"
                result = "OneHanded"
            Case "14"
                result = "Shield"
            Case "16"
                result = "Back"
            Case "17"
                result = "TwoHanded"
            Case "19"
                result = "Tabard"
            Case "21"
                result = "MainHand"
            Case "23"
                result = "OffHand"
            Case "28"
                result = "Relic"
        End Select
        Return result
    End Function

    Private Function getSlotID(ByVal slot As String) As String
        Dim result As String = slot
        Select Case slot
            Case "Head"
                result = "1"
            Case "Neck"
                result = "2"
            Case "Shoulders"
                result = "3"
            Case "Shirt"
                result = "4"
            Case "Chest"
                result = "5"
            Case "Waist"
                result = "6"
            Case "Legs"
                result = "7"
            Case "Feet"
                result = "8"
            Case "Wrist"
                result = "9"
            Case "Hands"
                result = "10"
            Case "Finger"
                result = "11"
            Case "Trinket"
                result = "12"
            Case "OneHanded"
                result = "13"
            Case "Shield"
                result = "14"
            Case "Back"
                result = "16"
            Case "TwoHanded"
                result = "17"
            Case "Tabard"
                result = "19"
            Case "MainHand"
                result = "21"
            Case "OffHand"
                result = "23"
            Case "Relic"
                result = "28"
        End Select
        Return result
    End Function

    Private Sub processComboBox()
        EnchantComboBox.Items.Clear()
        Dim item As DictionaryEntry
        For Each item In Variables.EnchantHash_Id
            Dim values() As String = Split(item.Value, ";")
            Dim name As String = values(1)
            If name = "" Then name = "Unknown"
            Dim slot As String = getSlotName(values(2))
            EnchantComboBox.Items.Add(values(1) & " ; (" & slot & ")")
        Next
        EnchantComboBox.Sorted = True
        EnchantComboBox.Text = ""
    End Sub
End Class

' Notes
'              0  1   2    3   4   5    6     7   8
'Enchants: 	' ID;Name;Slot;SP;Crit;Hit;Haste;Int;Stam
'
' CharSheet Slots
' 0 = Head
' 1 = Neck
' 2 = Shoulder
' 3 = Shirt
' 4 = Chest
' 5 = Waist
' 6 = Legs
' 7 = Feet
' 8 = Wrist
' 9 = Hands
' 10 = Finger 1
' 11 = Figner 2
' 12 = Trinket 1
' 13 = Trinket 2
' 14 = Back
' 15 = Mainhand
' 16 = Offhand
' 17 = Relic
' 18 = Tabard