﻿Imports System.IO

Public Class ItemEditor_Gear

    Private Sub ItemEditor_Shown(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Shown
        processComboBox()
    End Sub

    Private Sub ItemComboBox_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ItemComboBox.SelectedIndexChanged
        Dim item() As String = Split(Variables.AllItemsArray_Name.Item(ItemComboBox.Text), ";")
        SlotCombo.Text = Other.getSlotName(item(0).ToString)
        IDTextBox.Text = item(1)
        ArmorTextBox.Text = item(3)
        IntTextBox.Text = item(9)
        StamTextBox.Text = item(10)
        SpDmgTextBox.Text = item(11)
        HitTextBox.Text = item(12)
        CritTextBox.Text = item(13)
        HasteTextBox.Text = item(14)
        If item(5) <> "0" And item(5) <> "" Then
            Gem1Combo.Text = getGemColor(item(5).ToString)
        Else
            Gem1Combo.Text = ""
        End If
        If item(6) <> "0" And item(6) <> "" Then
            Gem2Combo.Text = getGemColor(item(6).ToString)
        Else
            Gem3Combo.Text = ""
        End If
        If item(7) <> "0" And item(7) <> "" Then
            Gem3Combo.Text = getGemColor(item(7).ToString)
        Else
            Gem3Combo.Text = ""
        End If
        If item(8) <> "" And item(8) <> "0" Then
            BonusCombo.Text = getBonusName(item(8))
        Else
            BonusCombo.Text = ""
        End If
    End Sub

    Private Sub GearEditSaveButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles GearEditSaveButton.Click
        Try
            ' Assemble new item string.
            Dim oldstring() As String = Split(Variables.AllItemsArray_Name.Item(ItemComboBox.Text), ";")
            Dim slot As String = Other.getSlotID(SlotCombo.Text)
            Dim gem0 As String = getGemColorID(Gem1Combo.Text)
            Dim gem1 As String = getGemColorID(Gem2Combo.Text)
            Dim gem2 As String = getGemColorID(Gem3Combo.Text)
            Dim bonus As String = getBonusID(BonusCombo.Text)
            Dim newstring As String = slot & ";" & IDTextBox.Text & ";" & ItemComboBox.Text & ";" & ArmorTextBox.Text & ";" & oldstring(4) & ";" & _
            gem0 & ";" & gem1 & ";" & gem2 & ";" & bonus & ";" & IntTextBox.Text & ";" & StamTextBox.Text & ";" & SpDmgTextBox.Text & ";" & _
            HitTextBox.Text & ";" & CritTextBox.Text & ";" & HasteTextBox.Text & ";" & oldstring(15) & ";" & oldstring(16)
            ' Update item array.
            Variables.AllItemsArray_Name(ItemComboBox.Text) = newstring
            Variables.AllItemsArray_Id(IDTextBox.Text) = newstring
            ' Rewrite item file.
            Dim objWriterArmor As New StreamWriter("data\gear.data", False)
            For Each item In Variables.AllItemsArray_Name
                objWriterArmor.WriteLine(item.value)
            Next
            objWriterArmor.Close()
            MessageBox.Show("Item saved")
        Catch ex As Exception
            MessageBox.Show("Error while saving:" & vbCrLf & ex.Message)
        End Try
    End Sub

    Private Sub GearEditDeleteButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles GearEditDeleteButton.Click
        Try
            If ItemComboBox.Text <> "" Then
                ' Delete from item array.
                Variables.AllItemsArray_Name.Remove(ItemComboBox.Text)
                Variables.AllItemsArray_Id.Remove(IDTextBox.Text)
                ' Rewrite item file.
                Dim objWriterArmor As New StreamWriter("data\gear.data", False)
                For Each item In Variables.AllItemsArray_Name
                    objWriterArmor.WriteLine(item.value)
                Next
                objWriterArmor.Close()
                MessageBox.Show("Item deleted")
                processComboBox()
            End If
        Catch ex As Exception
            MessageBox.Show("Error while deleting:" & vbCrLf & ex.Message)
        End Try
    End Sub

    Private Sub GearEditCloseButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles GearEditCloseButton.Click
        Me.Close()
    End Sub

    Private Function getGemColor(ByVal id As String) As String
        Dim result As String = id
        Select Case id
            Case "1"
                result = "Meta"
            Case "2"
                result = "Red"
            Case "4"
                result = "Yellow"
            Case "8"
                result = "Blue"
        End Select
        Return result
    End Function

    Private Function getGemColorID(ByVal color As String) As String
        Dim result As String = color
        Select Case color
            Case "Meta"
                result = "1"
            Case "Red"
                result = "2"
            Case "Yellow"
                result = "4"
            Case "Blue"
                result = "8"
        End Select
        Return result
    End Function

    Private Function getBonusID(ByVal bonus)
        Dim result As String = ""
        If bonus <> "" Then
            Dim raw() As String = Split(Variables.SocketBonus_Name.Item(bonus), ";")
            result = raw(0)
        End If
        Return result
    End Function

    Private Function getBonusName(ByVal bonus)
        Dim result As String = ""
        If bonus <> "" And bonus <> "0" Then
            Dim res() As String = Split(Variables.SocketBonus_Id(bonus), ";")
            result = res(2)
        End If
        Return result
    End Function

    Private Sub processComboBox()
        Dim selectedSlot As String = ""
        If SlotSelectComboBox.Text <> "" And SlotSelectComboBox.Text <> "All" Then selectedSlot = Other.getSlotID(SlotSelectComboBox.Text)

        ItemComboBox.Items.Clear()
        Dim item As DictionaryEntry
        For Each item In Variables.AllItemsArray_Name
            If selectedSlot <> "" Then
                Dim t() As String = Split(item.Value, ";")
                If t(0) = selectedSlot Then ItemComboBox.Items.Add(item.Key)
            Else
                ItemComboBox.Items.Add(item.Key)
            End If
        Next

        ItemComboBox.Sorted = True
        ItemComboBox.Text = ""

        BonusCombo.Items.Clear()
        Dim bonusitem As DictionaryEntry
        For Each bonusitem In Variables.SocketBonus_Name
            BonusCombo.Items.Add(bonusitem.Key)
        Next
        ItemComboBox.Sorted = True
        ItemComboBox.Text = ""
    End Sub

    Private Sub SlotSelectComboBox_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SlotSelectComboBox.SelectedIndexChanged
        processComboBox()
    End Sub
End Class

' Notes
'               ' 0     1   2      3      4          5     6     7       8        9   10     11           12    13    14      15         16
'Items: 		' Slot, ID, name, armor, set bonus, gem1, gem2, gem3, gem bonus, Int, Stam, Spell Damage, Hit, Crit, Haste, Display ID, Is Unique
'Gems:          ' ID, Name, Class, SP, Crit, Hit, Haste, Int, Stam, Hit Dmg, Crit Dmg
'Bonus:         ' ID, Item ID, Info, SP, Crit, Hit, Haste, Int, Stam, MP5