﻿Imports System.IO

Public Class ItemEditor_Sockets
    Private Sub ItemEditor_Sockets_Shown(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Shown
        processComboBox()
    End Sub

    Private Sub SocketCombo_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SocketCombo.SelectedIndexChanged
        If Variables.SocketBonus_Name.Item(SocketCombo.Text) <> "" Then
            Dim socket() As String = Split(Variables.SocketBonus_Name.Item(SocketCombo.Text), ";")
            AmountCombo.Text = ""
            TypeCombo.Text = ""
            IDTextBox.Text = socket(0)
            TypeCombo.Text = getBonusType(socket)
            FirstSeenTextBox.Text = getItemName(socket(1))
        End If
    End Sub

    Private Sub SocketSave_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SocketSave.Click
        If TypeCombo.Text <> "" And SocketCombo.Text <> "" Then
            Try
                Dim values As String = ""
                Dim newName As String = "+" & AmountCombo.Text & " " & TypeCombo.Text
                'Bonus          ' ID, Item ID, Info, SP, Crit, Hit, Haste, Int, Stam, MP5
                values &= IDTextBox.Text & ";"
                values &= getItemId(FirstSeenTextBox.Text) & ";"
                values &= newName & ";"
                values &= getBonusValues()

                Variables.SocketBonus_Name.Remove(SocketCombo.Text)
                If Not Variables.SocketBonus_Name.ContainsKey(newName) Then Variables.SocketBonus_Name.Item(newName) = values
                Variables.SocketBonus_Id.Item(IDTextBox.Text) = values
                Dim objWriterArmor As New StreamWriter("data\socketbonus.data", False)
                For Each item In Variables.SocketBonus_Id
                    If item.value <> "" Then
                        objWriterArmor.WriteLine(item.value)
                    End If
                Next
                objWriterArmor.Close()
                processComboBox()
                MessageBox.Show("Bonus saved")
            Catch ex As Exception
                MessageBox.Show("Error while saving:" & vbCrLf & ex.Message)
            End Try
        End If
    End Sub

    Private Sub SocketDelete_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SocketDelete.Click
        Try
            ' Delete from item array.
            Variables.SocketBonus_Name.Remove(SocketCombo.Text)
            Variables.SocketBonus_Id.Remove(IDTextBox.Text)
            ' Rewrite item file.
            Dim objWriterArmor As New StreamWriter("data\socketbonus.data", False)
            For Each item In Variables.SocketBonus_Name
                objWriterArmor.WriteLine(item.value)
            Next
            objWriterArmor.Close()
            processComboBox()
            MessageBox.Show("Socket Bonus deleted")
        Catch ex As Exception
            MessageBox.Show("Error while deleting:" & vbCrLf & ex.Message)
        End Try

    End Sub

    Private Sub SocketClose_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SocketClose.Click
        Me.Close()
    End Sub

    Private Sub processComboBox()
        SocketCombo.Text = ""
        TypeCombo.Text = ""
        AmountCombo.Text = ""
        FirstSeenTextBox.Text = ""
        IDTextBox.Text = ""
        SocketCombo.Items.Clear()
        Dim item As DictionaryEntry
        For Each item In Variables.SocketBonus_Name
            Dim values() As String = Split(item.Value, ";")
            If values(2) <> "+ Other" Then SocketCombo.Items.Add(values(2))
        Next
        SocketCombo.Sorted = True
    End Sub

    Private Function getBonusType(ByVal socket() As String) As String
        Dim result = ""
        If socket(3) <> "0" Then
            AmountCombo.Text = socket(3)
            result = "SP"
        ElseIf socket(4) <> "0" Then
            AmountCombo.Text = socket(4)
            result = "Crit"
        ElseIf socket(5) <> "0" Then
            AmountCombo.Text = socket(5)
            result = "Hit"
        ElseIf socket(6) <> "0" Then
            AmountCombo.Text = socket(6)
            result = "Haste"
        ElseIf socket(7) <> "0" Then
            AmountCombo.Text = socket(7)
            result = "Int"
        ElseIf socket(8) <> "0" Then
            AmountCombo.Text = socket(8)
            result = "Stam"
        ElseIf socket(9) <> "0" Then
            AmountCombo.Text = socket(9)
            result = "MP5"
        End If
        Return result
    End Function

    Private Function getItemName(ByVal id)
        Dim result As String = ""
        Dim data As Boolean = Variables.AllItemsArray_Id.Contains(id)
        If data = True Then
            Dim values() As String = Split(Variables.AllItemsArray_Id.Item(id), ";")
            result = values(2)
            Return result
        Else
            Return "Unknown"
        End If
    End Function

    Private Function getItemId(ByVal name)
        Dim result As String = ""
        Dim values() As String = Split(Variables.AllItemsArray_Name(name), ";")
        result = values(1)
        Return result
    End Function

    Private Function getBonusValues() As String
        Dim result As String = ""
        Dim sp As String = "0"
        Dim crit As String = "0"
        Dim hit As String = "0"
        Dim haste As String = "0"
        Dim inti As String = "0"
        Dim stam As String = "0"
        Dim mp5 As String = "0"
        If TypeCombo.Text = "SP" Then
            sp = AmountCombo.Text
        ElseIf TypeCombo.Text = "Crit" Then
            crit = AmountCombo.Text
        ElseIf TypeCombo.Text = "Hit" Then
            hit = AmountCombo.Text
        ElseIf TypeCombo.Text = "Haste" Then
            haste = AmountCombo.Text
        ElseIf TypeCombo.Text = "Int" Then
            inti = AmountCombo.Text
        ElseIf TypeCombo.Text = "Stam" Then
            stam = AmountCombo.Text
        ElseIf TypeCombo.Text = "MP5" Then
            mp5 = AmountCombo.Text
        End If
        result = sp & ";" & crit & ";" & hit & ";" & haste & ";" & inti & ";" & stam & ";" & mp5
        Return result
    End Function

    Private Sub TypeCombo_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TypeCombo.SelectedIndexChanged
        If TypeCombo.Text = "Other" Then
            AmountCombo.Enabled = False
        Else
            AmountCombo.Enabled = True
        End If
    End Sub
End Class

' Notes
'               ' 0    1       2     3    4    5     6      7    8    9
'Bonus          ' ID, Item ID, Info, SP, Crit, Hit, Haste, Int, Stam, MP5