﻿Imports System.Math

Module Spells
    ' Simulation spells
    Public Sub doLightningBolt(ByVal misspct, ByVal overload, ByVal currenttime, ByRef CLEARCAST, ByRef clearcastingstate, ByVal eleoathbonus, ByVal splo, ByVal sphi, ByVal extraSP)
        Dim hashit As Int16 = Other.checkForHit(misspct)
        If hashit = 1 Then
            ' Without modification, base crit is an additional 50% damage added to base damage.
            Dim critbonus As Decimal = 0.5
            ' Check for crit, 1 = not a crit, 2 = crit
            Dim hascrit As Decimal = Other.checkForCrit(Variables.StoredCritPerc, 0)
            ' Get base damage
            Dim basedmg As Integer = Other.RandomNumber(splo, sphi)

            ' Consider Coefficients, Concussion, and Glyph of Lightning Bolt
            ' Concussion and Glyph of LB are additive.  Will append more "additive" effects when I figure out which are.
            ' Currently do not know if LB Glyph modifies Overload procs, but we'll have it do so for now.
            Dim SpellMod1 As Decimal = CDec(Variables.TalentsHash.Item("Concuss")) + Variables.StoredGoLBCheck
            Dim lbdmg As Integer = (basedmg + ((Variables.StoredSpellDmg + extraSP) * Variables.Coefficients.Item("LB"))) * SpellMod1

            ' If the cast crit, consider all the bonuses applied to it.
            If hascrit = 2 Then
                ' Consider Meta Gem Crit bonus which applies to the base crit chance.
                If Variables.StoredMetaCrit = 1 Then critbonus = 0.545
                ' Consider Elemental Fury after the Meta.
                critbonus *= Variables.TalentsHash.Item("EleFury")
                ' Total bonus damage
                Dim critBonusDmg As Decimal = lbdmg * critbonus
                ' Add the crit bonus damage to the base damage
                lbdmg += critBonusDmg
            End If

            ' Consider Curse of Elements and Ebon Plaguebringer.
            lbdmg *= Variables.TalentsHash.Item("CurseOE")
            lbdmg *= Variables.TalentsHash.Item("EbonPlague")

            ' Consider Elemental Oath bonus Damage while Clearcasting active.  
            ' Is this figured before bonuses or after all bonuses?
            If clearcastingstate = 1 Then lbdmg *= eleoathbonus

            ' If this was an Overload proc, cut the damage in half.
            If overload = 4 Then lbdmg /= 2

            'lbdmg = Round(lbdmg, 0)
            Variables.rawDamage.Add(overload & "," & lbdmg.ToString & "," & hascrit.ToString & "," & clearcastingstate & "," & currenttime)
            If hascrit = 2 Then
                ' The spell crit, so put Elemental Oath and Clearcasting up
                If clearcastingstate = 0 Then rawDamage.Add("6") Else rawDamage.Add("10")
                CLEARCAST = 2
                clearcastingstate = 1
            Else
                ' Did not crit.  Check Clearcasting State (Only for standard LB)
                If overload <> 4 Then checkClearcasting(CLEARCAST, clearcastingstate)
            End If
        Else
            ' Whoosh, did not hit.  Check Clearcasting State (Only for standard LB)
            If overload <> 4 Then checkClearcasting(CLEARCAST, clearcastingstate)
            Variables.rawDamage.Add(overload & ",0,0," & clearcastingstate & "," & currenttime)
        End If
    End Sub

    Public Sub doLavaBurst(ByVal misspct, ByVal currentTime, ByRef CLEARCAST, ByRef clearcastingstate, ByVal FlameShockActive, ByVal eleoathbonus, ByVal splo, ByVal sphi)
        Dim hashit As Int16 = Other.checkForHit(misspct)
        If hashit = 1 Then
            ' Without modification, base crit is an additional 50% damage added to base damage.
            Dim critbonus As Decimal = 0.5
            ' Check for crit, 1 = not a crit, 2 = crit
            Dim hascrit As Decimal = 1
            If FlameShockActive = 1 Then
                'Flame Shock is on the target, 100% crit.
                hascrit = 2
            Else
                'Flame Shock is not on the target, check for crit.
                hascrit = Other.checkForCrit(Variables.StoredCritPerc, 1)
            End If

            ' Get base damage
            Dim basedmg As Integer = Other.RandomNumber(splo, sphi)
            ' Consider Coefficients, Concussion, and Call of Flame
            Dim lvbdmg As Integer = basedmg + (Variables.StoredSpellDmg * Variables.Coefficients.Item("LvB")) * (Variables.TalentsHash.Item("Concuss") + Variables.TalentsHash.Item("CallFla"))

            ' If the cast crit, consider all the bonuses applied to it.
            If hascrit = 2 Then
                ' Consider Meta Gem Crit bonus which applies to the base crit chance.
                If Variables.StoredMetaCrit = 1 Then critbonus = 0.545
                ' Consider Elemental Fury and Lava Flows after the Meta.
                critbonus *= Variables.TalentsHash.Item("EleFury") + Variables.TalentsHash.Item("LavaFlo")
                ' Total bonus damage
                Dim critBonusDmg As Decimal = lvbdmg * critbonus
                ' Add the crit bonus damage to the base damage.
                lvbdmg += critBonusDmg
            End If

            ' Consider Curse of Elements and Ebon Plaguebringer.
            lvbdmg *= Variables.TalentsHash.Item("CurseOE")
            lvbdmg *= Variables.TalentsHash.Item("EbonPlague")

            ' Consider Elemental Oath bonus Damage while Clearcasting active.
            ' Is this figured before bonuses or after all bonuses?
            If clearcastingstate = 1 Then lvbdmg *= eleoathbonus
            Variables.rawDamage.Add("1," & lvbdmg.ToString & "," & hascrit.ToString & "," & clearcastingstate & "," & currentTime)
            If hascrit = 2 Then
                ' The spell crit, so put Clearcasting up
                If clearcastingstate = 0 Then rawDamage.Add("6") Else rawDamage.Add("10")
                CLEARCAST = 2
                clearcastingstate = 1
            Else
                ' Did not crit.  Check Clearcasting State.
                checkClearcasting(CLEARCAST, clearcastingstate)
            End If
        Else
            ' Whoosh, did not hit.  Check Clearcasting State.
            checkClearcasting(CLEARCAST, clearcastingstate)
            Variables.rawDamage.Add("1,0,0," & clearcastingstate & "," & currentTime)
        End If
    End Sub

    Public Sub doFlameShock(ByVal misspct, ByVal currentTime, ByRef CLEARCAST, ByRef clearcastingstate, ByRef FlameShockActive, ByVal eleoathbonus, ByVal splo, ByVal sphi)
        Dim hashit As Int16 = Other.checkForHit(misspct)
        If hashit = 1 Then
            ' Without modification, base crit is an additional 50% damage added to base damage.
            Dim critbonus As Decimal = 0.5
            ' Check for crit, 1 = not a crit, 2 = crit
            Dim hascrit As Decimal = Other.checkForCrit(Variables.StoredCritPerc, 1)

            ' Get base damage
            Dim basedmg As Integer = Other.RandomNumber(splo, sphi)
            ' Consider Coefficients, Concussion and Booming Echoes
            Dim fsdmg As Integer = (basedmg + (Variables.StoredSpellDmg * Variables.Coefficients.Item("FS"))) * (Variables.TalentsHash.Item("Concuss") + Variables.TalentsHash.Item("BoomingEcho"))

            ' If the cast crit, consider all the bonuses applied to it.
            If hascrit = 2 Then
                ' Consider Meta Gem Crit bonus which applies to the base crit chance.
                If Variables.StoredMetaCrit = 1 Then critbonus = 0.545
                ' Consider Elemental Fury after the Meta.
                critbonus *= Variables.TalentsHash.Item("EleFury")
                ' Total bonus damage
                Dim critBonusDmg As Decimal = fsdmg * critbonus
                fsdmg += critBonusDmg
            End If

            ' Consider Curse of Elements and Ebon Plaguebringer.
            fsdmg *= Variables.TalentsHash.Item("CurseOE")
            fsdmg *= Variables.TalentsHash.Item("EbonPlague")

            ' Consider Elemental Oath bonus Damage while Clearcasting active.
            ' Is this figured before bonuses or after all bonuses?
            If clearcastingstate = 1 Then fsdmg *= eleoathbonus

            Variables.rawDamage.Add("2," & fsdmg.ToString & "," & hascrit.ToString & "," & clearcastingstate & "," & currentTime)
            FlameShockActive = 1
            If hascrit = 2 Then
                ' Spell crit, so put Clearcasting up
                If clearcastingstate = 0 Then rawDamage.Add("6") Else rawDamage.Add("10")
                CLEARCAST = 2
                clearcastingstate = 1
            Else
                ' Did not crit.  Check Clearcasting State.
                Other.checkClearcasting(CLEARCAST, clearcastingstate)
            End If
        Else
            ' Whoosh, did not hit.  Check Clearcasting State.
            Other.checkClearcasting(CLEARCAST, clearcastingstate)
            Variables.rawDamage.Add("2,0,0," & clearcastingstate & "," & currentTime)
            FlameShockActive = 0
        End If
    End Sub

    Public Sub doChainLightning(ByVal misspct, ByVal overload, ByVal currentTime, ByRef CLEARCAST, ByRef clearcastingstate, ByVal eleoathbonus, ByVal splo, ByVal sphi, ByVal extraSP)
        Dim hashit As Int16 = Other.checkForHit(misspct)
        If hashit = 1 Then
            ' Without modification, base crit is an additional 50% damage added to base damage.
            Dim critbonus As Decimal = 0.5
            ' Check for crit, 1 = not a crit, 2 = crit
            Dim hascrit As Decimal = Other.checkForCrit(Variables.StoredCritPerc, 0)

            ' Get base damage
            Dim basedmg As Integer = Other.RandomNumber(splo, sphi)

            ' Consider Coefficients and Concussion
            Dim cldmg As Integer = ((basedmg + ((Variables.StoredSpellDmg + extraSP) * Variables.Coefficients.Item("CL"))) * Variables.TalentsHash.Item("Concuss"))

            ' If the cast crit, consider all the bonuses applied to it.
            If hascrit = 2 Then
                ' Consider Meta Gem Crit bonus which applies to the base crit chance.
                If Variables.StoredMetaCrit = 1 Then critbonus = 0.545
                ' Consider Elemental Fury after the Meta.
                critbonus *= Variables.TalentsHash.Item("EleFury")
                ' Total bonus damage
                Dim critBonusDmg As Decimal = cldmg * critbonus
                cldmg += critBonusDmg
            End If

            ' Consider Curse of Elements and Ebon Plaguebringer.
            cldmg *= Variables.TalentsHash.Item("CurseOE")
            cldmg *= Variables.TalentsHash.Item("EbonPlague")

            ' Consider Elemental Oath bonus Damage while Clearcasting active.
            ' Same question as always
            If clearcastingstate = 1 Then cldmg *= eleoathbonus

            ' If this was an Overload proc, cut the damage in half.
            If overload = 4 Then cldmg /= 2

            Variables.rawDamage.Add(overload & "," & cldmg.ToString & "," & hascrit.ToString & "," & clearcastingstate & "," & currentTime)
            If hascrit = 2 Then
                ' Spell crit, so put Clearcasting up
                rawDamage.Add("6")
                CLEARCAST = 2
                clearcastingstate = 1
            Else
                ' Did not crit.  Check Clearcasting State.
                If overload <> 4 Then checkClearcasting(CLEARCAST, clearcastingstate)
            End If
        Else
            ' Whoosh, did not hit.  Check Clearcasting State.
            If overload <> 4 Then checkClearcasting(CLEARCAST, clearcastingstate)
            Variables.rawDamage.Add(overload & ",0,0," & clearcastingstate & "," & currentTime)
        End If
    End Sub

    Public Function doFlameShockDoT(ByVal fsdotav, ByVal dmgbonus, ByVal CCActive, ByVal eleoathbonus) As String()
        Dim fscur As Integer = 0
        Dim hascrit As Decimal = 0
        ' Make a DoT
        Dim fsdot As Integer = fsdotav / 6
        ' Consider Storm Earth & Fire bonus to SpellPower
        Dim sef As Integer = dmgbonus * ((CInt(Variables.TalentsHash.Item("StormEarthFire")) * 20) / 100)
        ' Modify Spellpower by Coefficient
        Dim sppower As Integer = (dmgbonus + sef) * CDec(Variables.Coefficients.Item("FSDoT"))
        ' Consider Concussion bonus to damage.
        Dim con As Integer = fsdot * (1 - CDec(Variables.TalentsHash.Item("Concuss")))
        ' Add it up.
        fscur = fsdot + con + sppower

        ' Consider Elemental Oath bonus Damage while Clearcasting active.
        ' Is this figured before bonuses or after all bonuses?
        If CCActive = 1 Then fscur *= eleoathbonus

        ' Consider critical hits, if applicable (Always applicable now).
        ' Without modification, base crit is an additional 50% damage added to base damage.
        Dim critbonus As Decimal = 0.5
        ' Check for crit, 1 = not a crit, 2 = crit
        hascrit = Other.checkForCrit(Variables.StoredCritPerc, 1)
        If hascrit = 2 Then
            ' Consider Meta Gem Crit bonus which applies to the base crit chance.
            If Variables.StoredMetaCrit = 1 Then critbonus = 0.545
            ' Consider Elemental Fury after the Meta.
            critbonus *= Variables.TalentsHash.Item("EleFury")
            ' Total bonus damage
            Dim critBonusDmg As Decimal = fscur * critbonus
            ' Add the crit bonus damage to the base damage
            fscur += critBonusDmg
        End If
        Dim result() As String = {fscur, hascrit}
        Return result
    End Function

    ' Model Spells
    Public Function doLightningBoltModel(ByVal lbav, ByVal critdec, ByVal hitpct, ByVal dmgbonus, ByVal extraSP)
        Dim lbcur As Integer = 0
        lbcur = CInt(lbav + ((Variables.StoredSpellDmg + extraSP) * Variables.Coefficients.Item("LB")))
        ' Consider Concussion & Glyph of Lightning Bolt
        lbcur *= CDec(Variables.TalentsHash.Item("Concuss")) + Variables.StoredGoLBCheck

        ' Consider critical hits. 
        ' critDec is the effective crit percent in decimal plus 1 (So 34% crit rate would come in as 1.34)
        ' We can assume that percentage of hits will be "double" damage. (Or each hit can add that % of damage to the total)
        Dim critbonus As Decimal = 0.5
        If Variables.StoredMetaCrit = 1 Then critbonus = 0.545
        critbonus *= Variables.TalentsHash.Item("EleFury")
        Dim critBonusDmg As Decimal = lbcur * critbonus
        critBonusDmg *= critdec - 1

        lbcur += critBonusDmg

        ' Consider Curse of Elements and Ebon Plaguebringer.
        lbcur *= Variables.TalentsHash.Item("CurseOE")
        lbcur *= Variables.TalentsHash.Item("EbonPlague")

        ' Consider Hit Percentage.
        lbcur *= hitpct

        lbcur = Round(lbcur * dmgbonus, 0)
        Return lbcur
    End Function

    Public Function doLavaBurstModel(ByVal lvbav, ByVal critdec, ByVal hitpct, ByVal dmgbonus)
        Dim lvbcur As Integer = 0
        lvbcur = CInt((lvbav + (Variables.StoredSpellDmg * Variables.Coefficients.Item("LvB"))))
        ' Consider Cuncussion and Call of Flame
        lvbcur *= Variables.TalentsHash.Item("Concuss") + Variables.TalentsHash.Item("CallFla")

        ' Consider critical hits.
        ' Since Lava Burst always crits with Flame Shock on the target, and we always make sure FS is up, LvB's crit rate
        ' will be determined by our HIT rate, and not our crit rate.
        Dim critbonus As Decimal = 0.5
        If Variables.StoredMetaCrit = 1 Then critbonus = 0.545
        critbonus *= Variables.TalentsHash.Item("EleFury") + Variables.TalentsHash.Item("LavaFlo")
        Dim critBonusDmg As Decimal = lvbcur * critbonus
        critBonusDmg *= hitpct

        lvbcur += critBonusDmg

        ' Consider Curse of Elements and Ebon Plaguebringer.
        lvbcur *= Variables.TalentsHash.Item("CurseOE")
        lvbcur *= Variables.TalentsHash.Item("EbonPlague")

        ' Consider Hit Percentage.
        lvbcur *= hitpct

        lvbcur = Round(lvbcur * dmgbonus, 0)
        Return lvbcur
    End Function

    Public Function doFlameShockModel(ByVal fsav, ByVal critdec, ByVal hitpct, ByVal dmgbonus)
        Dim fscur As Integer = 0
        fscur = CInt((fsav + (Variables.StoredSpellDmg * Variables.Coefficients.Item("FS"))) * (Variables.TalentsHash.Item("Concuss") + Variables.TalentsHash.Item("BoomingEcho")))

        ' Consider critical hits.
        ' critDec is the effective crit percent in decimal plus 1 (So 34% crit rate would come in as 1.34)
        ' We can assume that percentage of hits will be "double" damage. (Or each hit can add that % of damage to the total)

        Dim critbonus As Decimal = 0.5
        If Variables.StoredMetaCrit = 1 Then critbonus = 0.545
        critbonus *= Variables.TalentsHash.Item("EleFury")
        Dim critBonusDmg As Decimal = fscur * critbonus
        critBonusDmg *= critdec - 1

        fscur += critBonusDmg

        ' Consider Curse of Elements and Ebon Plaguebringer.
        fscur *= Variables.TalentsHash.Item("CurseOE")
        fscur *= Variables.TalentsHash.Item("EbonPlague")
        ' Consider Hit Percentage.
        fscur *= hitpct

        fscur = Round(fscur * dmgbonus, 0)
        Return fscur
    End Function

    Public Function doFlameShockDoTModel(ByVal fsdotav, ByVal dmgbonus, ByVal critdec)
        Dim fscur As Integer = 0
        ' Make a DoT
        Dim fsdot As Integer = fsdotav / 6
        ' Consider Storm Earth & Fire bonus to SpellPower
        Dim sef As Integer = dmgbonus * ((CInt(Variables.TalentsHash.Item("StormEarthFire")) * 20) / 100)
        ' Modify Spellpower by Coefficient
        Dim sppower As Integer = (dmgbonus + sef) * CDec(Variables.Coefficients.Item("FSDoT"))
        ' Consider Concussion bonus to damage.
        Dim con As Integer = fsdot * (1 - CDec(Variables.TalentsHash.Item("Concuss")))
        ' Add it up.
        fscur = fsdot + con + sppower

        ' Consider critical hits, if applicable (Always applicable now).
        Dim critbonus As Decimal = 0.5
        If Variables.StoredMetaCrit = 1 Then critbonus = 0.545
        critbonus *= Variables.TalentsHash.Item("EleFury")
        Dim critBonusDmg As Decimal = fscur * critbonus
        critBonusDmg *= critdec - 1
        fscur += critBonusDmg

        Return fscur
    End Function

    Public Function doChainLightningModel(ByVal clav, ByVal critdec, ByVal hitpct, ByVal dmgbonus, ByVal extraSP)
        Dim clcur As Integer = 0
        clcur = CInt(clav + ((Variables.StoredSpellDmg + extraSP) * Variables.Coefficients.Item("CL")))
        ' Consider Concussion
        clcur *= Variables.TalentsHash.Item("Concuss")

        ' Consider critical hits. 
        ' critDec is the effective crit percent in decimal plus 1 (So 34% crit rate would come in as 1.34)
        ' We can assume that percentage of hits will be "double" damage. (Or each hit can add that % of damage to the total)
        Dim critbonus As Decimal = 0.5
        If Variables.StoredMetaCrit = 1 Then critbonus = 0.545
        critbonus *= Variables.TalentsHash.Item("EleFury")
        Dim critBonusDmg As Decimal = clcur * critbonus
        critBonusDmg *= critdec - 1

        clcur += critBonusDmg

        ' Consider Curse of Elements and Ebon Plaguebringer.
        clcur *= Variables.TalentsHash.Item("CurseOE")
        clcur *= Variables.TalentsHash.Item("EbonPlague")
        ' Consider Hit Percentage.
        clcur *= hitpct

        clcur = Round(clcur * dmgbonus, 0)
        Return clcur
    End Function

    ' Statistic Spells
    Public Function doLightningBoltStat()
        Dim result As String = ""
        Dim lbinfo() As String = Split(Variables.Spells.Item("LB" & Variables.StoredShamanLevel), ",")
        Dim extraSP As Integer = 0
        If Variables.CurrentGear.Item("Relic") <> "" Then
            ' Manually check for Totem of Hex
            If Variables.CurrentGear.Item("Relic").ToString.Contains("40267") Then extraSP = 165
            ' Manually check for Totem of the Void
            If Variables.CurrentGear.Item("Relic").ToString.Contains("28248") Then extraSP = 55
        End If

        Dim lbdmglo As Integer = ((lbinfo(0) + ((Variables.StoredSpellDmg + extraSP) * Variables.Coefficients.Item("LB"))))
        Dim lbdmghi As Integer = ((lbinfo(1) + ((Variables.StoredSpellDmg + extraSP) * Variables.Coefficients.Item("LB"))))
        ' Concussion & Glyph of Lightning Bolt
        lbdmglo *= Variables.TalentsHash.Item("Concuss") + Variables.StoredGoLBCheck
        lbdmghi *= Variables.TalentsHash.Item("Concuss") + Variables.StoredGoLBCheck

        ' Crit bonus damage
        Dim critbonus As Decimal = 0.5
        If Variables.StoredMetaCrit = 1 Then critbonus = 0.545
        critbonus *= Variables.TalentsHash.Item("EleFury")
        Dim lbcritlo As Decimal = Round((lbdmglo * critbonus) + lbdmglo, 0)
        Dim lbcrithi As Decimal = Round((lbdmghi * critbonus) + lbdmghi, 0)

        ' Curse of Elements and Ebon Plaguebringer.
        lbdmglo *= Variables.TalentsHash.Item("CurseOE")
        lbdmglo *= Variables.TalentsHash.Item("EbonPlague")
        lbdmghi *= Variables.TalentsHash.Item("CurseOE")
        lbdmghi *= Variables.TalentsHash.Item("EbonPlague")
        lbcritlo *= Variables.TalentsHash.Item("CurseOE")
        lbcritlo *= Variables.TalentsHash.Item("EbonPlague")
        lbcrithi *= Variables.TalentsHash.Item("CurseOE")
        lbcrithi *= Variables.TalentsHash.Item("EbonPlague")

        Dim eleoathbonus As Decimal = 1.0
        If Variables.TalentsHash.Item("EleOath") = "3" Then
            eleoathbonus = 1.05
        ElseIf Variables.TalentsHash.Item("EleOath") = "5" Then
            eleoathbonus = 1.1
        End If

        ' Elemental Oath bonus Damage while Clearcasting active.
        Dim lbcclo As Integer = lbdmglo * eleoathbonus
        Dim lbcchi As Integer = lbdmghi * eleoathbonus
        Dim lbccclo As Integer = lbcritlo * eleoathbonus
        Dim lbccchi As Integer = lbcrithi * eleoathbonus

        result = "Lightning Bolt Damage: " & lbdmglo & " - " & lbdmghi & " (With CC up: " & lbcclo & " - " & lbcchi & ")" & vbCrLf
        result &= "Lightning Bolt Crit Damage: " & lbcritlo & " - " & lbcrithi & " (With CC up: " & lbccclo & " - " & lbccchi & ")" & vbCrLf
        Return result
    End Function

    Function doLavaBurstStat()
        Dim result As String = ""
        Dim lvbinfo() As String = Split(Variables.Spells.Item("LvB" & Variables.StoredShamanLevel), ",")
        If Variables.CurrentGear.Item("Relic") <> "" Then
            If Variables.CurrentGear.Item("Relic").ToString.Contains("38361") Then
                lvbinfo(0) += 121
                lvbinfo(1) += 121
            End If
        End If

        Dim lvbdmglo As Integer = lvbinfo(0) + (Variables.StoredSpellDmg * Variables.Coefficients.Item("LvB"))
        Dim lvbdmghi As Integer = lvbinfo(1) + (Variables.StoredSpellDmg * Variables.Coefficients.Item("LvB"))
        ' Concussion and Call of Flame
        lvbdmglo *= Variables.TalentsHash.Item("Concuss") + Variables.TalentsHash.Item("CallFla")
        lvbdmghi *= Variables.TalentsHash.Item("Concuss") + Variables.TalentsHash.Item("CallFla")

        ' Crit bonus damage
        Dim critbonus As Decimal = 0.5
        If Variables.StoredMetaCrit = 1 Then critbonus = 0.545
        critbonus *= Variables.TalentsHash.Item("EleFury") + Variables.TalentsHash.Item("LavaFlo")
        Dim lvbcritlo As Decimal = Round((lvbdmglo * critbonus) + lvbdmglo, 0)
        Dim lvbcrithi As Decimal = Round((lvbdmghi * critbonus) + lvbdmghi, 0)


        ' Curse of Elements and Ebon Plaguebringer
        lvbdmglo *= Variables.TalentsHash.Item("CurseOE")
        lvbdmglo *= Variables.TalentsHash.Item("EbonPlague")
        lvbdmghi *= Variables.TalentsHash.Item("CurseOE")
        lvbdmghi *= Variables.TalentsHash.Item("EbonPlague")
        lvbcritlo *= Variables.TalentsHash.Item("CurseOE")
        lvbcritlo *= Variables.TalentsHash.Item("EbonPlague")
        lvbcrithi *= Variables.TalentsHash.Item("CurseOE")
        lvbcrithi *= Variables.TalentsHash.Item("EbonPlague")

        Dim eleoathbonus As Decimal = 1.0
        If Variables.TalentsHash.Item("EleOath") = "3" Then
            eleoathbonus = 1.05
        ElseIf Variables.TalentsHash.Item("EleOath") = "5" Then
            eleoathbonus = 1.1
        End If

        ' Elemental Oath bonus Damage while Clearcasting active.
        Dim lvbcclo As Integer = lvbdmglo * eleoathbonus
        Dim lvbcchi As Integer = lvbdmghi * eleoathbonus
        Dim lvbccclo As Integer = lvbcritlo * eleoathbonus
        Dim lvbccchi As Integer = lvbcrithi * eleoathbonus

        result = "Lava Burst Damage: " & lvbdmglo & " - " & lvbdmghi & " (With CC up: " & lvbcclo & " - " & lvbcchi & ")" & vbCrLf
        result &= "Lava Burst Crit Damage: " & lvbcritlo & " - " & lvbcrithi & " (With CC up: " & lvbccclo & " - " & lvbccchi & ")" & vbCrLf
        Return result
    End Function
End Module
